unit ui4gh;
	{ User Interface for GearHead. }
	{ This unit exists to keep me from copying changes back and forth between }
	{ the SDL mode units and the CRT mode units... }
{
	GearHead: Arena, a roguelike mecha CRPG
	Copyright (C) 2005 Joseph Hewitt

	This library is free software; you can redistribute it and/or modify it
	under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation; either version 2.1 of the License, or (at
	your option) any later version.

	The full text of the LGPL can be found in license.txt.

	This library is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
	General Public License for more details. 

	You should have received a copy of the GNU Lesser General Public License
	along with this library; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
}


interface

{$IFDEF PATCH_GH}
  {$IF DEFINED(SDLMODE) OR DEFINED(ASCII_SDL)}
    {$IFDEF SDL2}
uses	SDL2;
    {$ELSE SDL2}
uses	SDL;
    {$ENDIF SDL2}
  {$ENDIF}
{$ENDIF PATCH_GH}

type
	KeyMapDesc = Record
		CmdName,CmdDesc: String;
		KCode: Char;
	end;

{$IFDEF PATCH_GH}
	KeyMapAliasDesc = Record
		CmdAlias: String;
		CmdName: String;
	end;

	T_KCodeAlias = Record
		KCode_from: Char;
		KCode_to: Char;
	end;
{$ENDIF PATCH_GH}

{$IFDEF PATCH_I18N}
	FontSearchNameDesc = Record
		FontFile: String;
		FontFace: Integer;
		FontSize: Integer;
	end;
	PFontSearchNameDesc = ^FontSearchNameDesc;
{$ENDIF PATCH_I18N}

const
{$IFDEF PATCH_GH}
	KBD_F1  = #$A0;
	KBD_F2  = #$A1;
	KBD_F3  = #$A2;
	KBD_F4  = #$A3;
	KBD_F5  = #$A4;
	KBD_F6  = #$A5;
	KBD_F7  = #$A6;
	KBD_F8  = #$A7;
	KBD_F9  = #$A8;
	KBD_F10 = #$A9;
	KBD_F11 = #$AA;
	KBD_F12 = #$AB;
	KBD_F13 = #$AC;
	KBD_F14 = #$AD;
	KBD_F15 = #$AE;
	KBD_F16 = #$AF;
	KBD_F17 = #$B0;
	KBD_F18 = #$B1;
	KBD_F19 = #$B2;
	KBD_F20 = #$B3;
	KBD_LWin   = #$C0;
	KBD_RWin   = #$C1;
	KBD_Apps   = #$C2;
	KBD_Home   = #$C3;
	KBD_Up     = #$C4;
	KBD_PgUp   = #$C5;
	KBD_Left   = #$C6;
	KBD_KP5    = #$C7;
	KBD_Right  = #$C8;
	KBD_End    = #$C9;
	KBD_Down   = #$CA;
	KBD_PgDn   = #$CB;
	KBD_Insert = #$CC;
	KBD_Delete = #$CD;
	KBD_BS  = #$08;
	KBD_TAB = #$09;
	KBD_RET = #$0D;
	KBD_LF  = #$0A;
	KBD_ESC = #$1B;
	KBD_CTRL_A = #$01;
	KBD_CTRL_B = #$02;
	KBD_CTRL_C = #$03;
	KBD_CTRL_D = #$04;
	KBD_CTRL_E = #$05;
	KBD_CTRL_F = #$06;
	KBD_CTRL_G = #$07;
	KBD_CTRL_H = #$08;
	KBD_CTRL_I = #$09;
	KBD_CTRL_J = #$0A;
	KBD_CTRL_K = #$0B;
	KBD_CTRL_L = #$0C;
	KBD_CTRL_M = #$0D;
	KBD_CTRL_N = #$0E;
	KBD_CTRL_O = #$0F;
	KBD_CTRL_P = #$10;
	KBD_CTRL_Q = #$11;
	KBD_CTRL_R = #$12;
	KBD_CTRL_S = #$13;
	KBD_CTRL_T = #$14;
	KBD_CTRL_U = #$15;
	KBD_CTRL_V = #$16;
	KBD_CTRL_W = #$17;
	KBD_CTRL_X = #$18;
	KBD_CTRL_Y = #$19;
	KBD_CTRL_Z = #$1A;
	KBD_UNICODE_FLAG = #$80;
	KBD_NONE   = #$00;
	KBD_ERROR  = #$FF;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_GH}
	RPK_UpRight = '9';
	RPK_Up = '8';
	RPK_UpLeft = '7';
	RPK_Left = '4';
	RPK_Right = '6';
	RPK_DownRight = '3';
	RPK_Down = '2';
	RPK_DownLeft = '1';
	RPK_Center = '5';
	RPK_MouseButton = #$90;
	RPK_TimeEvent = #$91;
	RPK_RightButton = #$92;
	RPK_MouseButtonRelease = #$93;
	RPK_MouseMotion = #$94;

	FrameDelay: Integer = 50;
{$ELSE PATCH_GH}
	RPK_UpRight = '9';
	RPK_Up = '8';
	RPK_UpLeft = '7';
	RPK_Left = '4';
	RPK_Right = '6';
	RPK_DownRight = '3';
	RPK_Down = '2';
	RPK_DownLeft = '1';

{$IFDEF SDLMODE}
	RPK_MouseButton = #$90;
	RPK_TimeEvent = #$91;
	RPK_RightButton = #$92;
	FrameDelay: Integer = 50;
{$ELSE}
	FrameDelay: Integer = 100;
{$ENDIF}
{$ENDIF PATCH_GH}

	MenuBasedInput = 0;
	RLBasedInput = 1;
	ControlMethod: Byte = MenuBasedInput;
	CharacterMethod: Byte = RLBasedInput;
	WorldMapMethod: Byte = RLBasedInput;
	{ PATCH_I18N: Converted by Load_I18N_Default }
	ControlTypeName: Array [0..1] of string = ('Menu','Roguelike');

	DoFullScreen: Boolean = False;
	Mouse_Active: Boolean = True;

	Always_Save_Character: Boolean = False;
	No_Combat_Taunts: Boolean = False;
	Pillage_On: Boolean = True;

	TacticsRoundLength: Integer = 60;

	PC_SHOULD_RUN: Boolean = False;

	BV_Off = 1;
	BV_Quarter = 2;
	BV_Half = 3;
	BV_Max = 4;
	DefMissileBV: Byte = BV_Quarter;
	DefBallisticBV: Byte = BV_Max;
	DefBeamgunBV: Byte = BV_Max;
	{ PATCH_I18N: Converted by Load_I18N_Default }
	BVTypeName: Array [1..4] of string = ('Off','1/4','1/2','Max');

	DoAutoSave: Boolean = True;

	Use_Alpha_Blending: Boolean = True;
	Alpha_Level: Byte = 135;
	Transparent_Interface: Boolean = True;

	Names_Above_Heads: Boolean = False;

	Max_Plots_Per_Adventure: Byte = 50;
	Load_Plots_At_Start: Boolean = False;

	Display_Mini_Map: Boolean = False;
{$IFDEF PATCH_GH}
	Display_Mini_Map_with_All_Gears: Boolean = False;
{$ENDIF PATCH_GH}

	UseTacticsMode: Boolean = False;

	UseAdvancedColoring: Boolean = False;

	Accessibility_On: Boolean = False;

	{ *** SCREEN DIMENSIONS *** }
	ScreenRows: Byte = 25;
	ScreenColumns: Byte = 80;

{$IFDEF PATCH_GH}
	Direct_Skill_Learning: Boolean = False;
{$ENDIF PATCH_GH}


{$IFDEF ENABLE_ADDRESSBOOK}
	NumMappedKeys_ADDRESSBOOK = 1;
{$ELSE ENABLE_ADDRESSBOOK}
	NumMappedKeys_ADDRESSBOOK = 0;
{$ENDIF ENABLE_ADDRESSBOOK}
{$IFDEF PATCH_JPSSDL}
	NumMappedKeys_JPSSDL = 1;
{$ELSE PATCH_JPSSDL}
	NumMappedKeys_JPSSDL = 0;
{$ENDIF PATCH_JPSSDL}
{$IFDEF PATCH_GH}
	NumMappedKeys_GH = 23;
{$ELSE PATCH_GH}
	NumMappedKeys_GH = 0;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
	NumMappedKeys_HEART = 1;
{$ELSE PATCH_HEART}
	NumMappedKeys_HEART = 0;
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_CHEAT}
	NumMappedKeys_CHEAT = 5;
{$ELSE PATCH_CHEAT}
	NumMappedKeys_CHEAT = 0;
{$ENDIF PATCH_CHEAT}
	NumMappedKeys_DEBUG = 1;
	NumMappedKeys = 45 + NumMappedKeys_ADDRESSBOOK + NumMappedKeys_JPSSDL + NumMappedKeys_GH + NumMappedKeys_HEART + NumMappedKeys_CHEAT + NumMappedKeys_DEBUG;
	KeyMap: Array [1..NumMappedKeys] of KeyMapDesc = (
	(	CmdName: 'NormSpeed';
		CmdDesc: 'Travel foreword at normal speed.';
		KCode: '=';	),
	(	CmdName: 'FullSpeed';
		CmdDesc: 'Travel foreword at maximum speed';
		KCode: '+';	),
	(	CmdName: 'TurnLeft';
		CmdDesc: 'Turn to the left.';
		KCode: '[';	),
	(	CmdName: 'TurnRight';
		CmdDesc: 'Turn to the right.';
		KCode: ']';	),
	(	CmdName: 'Stop';
		CmdDesc: 'Stop moving, wait in place.';
		KCode: '5';	),

{$IFDEF SDLMODE}
{ In SDL Mode, the direction keys for movement need to be shifted }
{ in order to match the isometric display. }
	(	CmdName: 'Dir-SouthWest';
		CmdDesc: 'Move southwest.';
		KCode: RPK_Left;	),
	(	CmdName: 'Dir-South';
		CmdDesc: 'Move south.';
		KCode: RPK_DownLeft;	),
	(	CmdName: 'Dir-SouthEast';
		CmdDesc: 'Move southeast.';
		KCode: RPK_Down;	),
	(	CmdName: 'Dir-West';
		CmdDesc: 'Move west.';
		KCode: RPK_UpLeft;	),
	(	CmdName: 'Dir-East';
		CmdDesc: 'Move east.';
		KCode: RPK_DownRight;	),

	(	CmdName: 'Dir-NorthWest';
		CmdDesc: 'Move northwest.';
		KCode: RPK_Up;	),
	(	CmdName: 'Dir-North';
		CmdDesc: 'Move north.';
		KCode: RPK_UpRight;	),
	(	CmdName: 'Dir-NorthEast';
		CmdDesc: 'Move northeast.';
		KCode: RPK_Right;	),
{$ELSE SDLMODE}
	(	CmdName: 'Dir-SouthWest';
		CmdDesc: 'Move southwest.';
		KCode: RPK_DownLeft;	),
	(	CmdName: 'Dir-South';
		CmdDesc: 'Move south.';
		KCode: RPK_Down;	),
	(	CmdName: 'Dir-SouthEast';
		CmdDesc: 'Move southeast.';
		KCode: RPK_DownRight;	),
	(	CmdName: 'Dir-West';
		CmdDesc: 'Move west.';
		KCode: RPK_Left;	),
	(	CmdName: 'Dir-East';
		CmdDesc: 'Move east.';
		KCode: RPK_Right;	),

	(	CmdName: 'Dir-NorthWest';
		CmdDesc: 'Move northwest.';
		KCode: RPK_UpLeft;	),
	(	CmdName: 'Dir-North';
		CmdDesc: 'Move north.';
		KCode: RPK_Up;	),
	(	CmdName: 'Dir-NorthEast';
		CmdDesc: 'Move northeast.';
		KCode: RPK_UpRight;	),
{$ENDIF SDLMODE}

	(	CmdName: 'ShiftGears';
		CmdDesc: 'Change movement mode.';
		KCode: '.';	),
	(	CmdName: 'Look';
		CmdDesc: 'Look around the map.';
		KCode: 'l';	),

	(	CmdName: 'AttackMenu';
		CmdDesc: 'Access the attack menu.';
		KCode: 'A';	),
	(	CmdName: 'QuitGame';
		CmdDesc: 'Exit the game.';
		KCode: 'Q';	),
	(	CmdName: 'Talk';
		CmdDesc: 'Initiate conversation with a NPC.';
		KCode: 't';	),
	(	CmdName: 'Help';
		CmdDesc: 'View these helpful messages.';
		KCode: 'h';	),
	(	CmdName: 'SwitchWeapon';
		CmdDesc: 'Change the active weapon while selecting a target.';
		KCode: '.';	),

	(	CmdName: 'CalledShot';
		CmdDesc: 'Toggle the Called Shot option while selecting a target.';
		KCode: '/';	),
	(	CmdName: 'Recenter';
		CmdDesc: 'Recenter the display on the currently active character.';
		KCode: 'R';	),
	(	CmdName: 'Get';
		CmdDesc: 'Pick up an item lying on the ground.';
		KCode: ',';	),
	(	CmdName: 'Inventory';
		CmdDesc: 'Access all carried items.';
		KCode: 'i';	),
	(	CmdName: 'Equipment';
		CmdDesc: 'Access all equipped items.';
		KCode: 'e';	),

	{ Commands 26 - 30 }
	(	CmdName: 'Enter';
		CmdDesc: 'Use a stairway or portal.';
		KCode: '>';	),
	(	CmdName: 'PartBrowser';
		CmdDesc: 'Examine the individual components of your PC.';
		KCode: 'B';	),
	(	CmdName: 'LearnSkills';
		CmdDesc: 'Spend accumulated experience points.';
		KCode: 'L';	),
	(	CmdName: 'Attack';
		CmdDesc: 'Perform an attack.';
		KCode: 'a';	),
	(	CmdName: 'UseScenery';
		CmdDesc: 'Activate a stationary item, such as a door or a computer.';
		KCode: 'u';	),

	{ Commands 31 - 35 }
	(	CmdName: 'Messages';
		CmdDesc: 'Review all current adventure memos, email, and news.';
		KCode: 'm';	),
	(	CmdName: 'SaveGame';
		CmdDesc: 'Write the game data to disk, so you can come back and waste time later.';
		KCode: 'X';	),
	(	CmdName: 'Enter2';
		CmdDesc: 'Use a stairway or portal.';
		KCode: '<';	),
	(	CmdName: 'CharInfo';
		CmdDesc: 'View detailed information about your character, access option menus.';
		KCode: 'C';	),
	(	CmdName: 'ApplySkill';
		CmdDesc: 'Select and use a skill that the PC knows.';
		KCode: 's';	),

	{ Commands 36 - 40 }
	(	CmdName: 'Eject';
		CmdDesc: 'Eject from your mecha and abandon it on the field.';
		KCode: 'E';	),
	(	CmdName: 'Rest';
		CmdDesc: 'Take a break for one hour of game time.';
		KCode: 'Z';	),
	(	CmdName: 'History';
		CmdDesc: 'Display past messages.';
		KCode: 'V';	),
	(	CmdName: 'FieldHQ';
		CmdDesc: 'Examine and edit your personal wargear.';
		KCode: 'H';	),
	(	CmdName: 'Search';
		CmdDesc: 'Check the area for enemies and secrets.';
		KCode: 'S';	),

	{ Commands 41 - 45 }
	(	CmdName: 'Telephone';
		CmdDesc: 'Place a telephone call to a local NPC.';
		KCode: 'T';	),
	(	CmdName: 'SwitchBV';
		CmdDesc: 'Switch the Burst Fire option while selecting a target.';
		KCode: '>';	),
	(	CmdName: 'Reverse';
		CmdDesc: 'Travel backward at normal speed.';
		KCode: '-';	),
	(	CmdName: 'SwitchTarget';
		CmdDesc: 'Switch to next visible enemy when selecting a target.';
		KCode: ';';	),
	(	CmdName: 'RunToggle';
		CmdDesc: 'Toggle running on or off.';
		KCode: 'r';	)

	{ Commands 46 - 50 }
{$IFDEF ENABLE_ADDRESSBOOK}
	,
	(	CmdName: 'AddressBook';
		CmdDesc: 'Use AddressBook.';
		KCode:	'b'; )
{$ENDIF ENABLE_ADDRESSBOOK}
{$IFDEF PATCH_JPSSDL}
	,
	(	CmdName: 'ToggleDrawWall';
		CmdDesc: 'Toggle Draw Wall.';
		KCode:	'0'; )
{$ENDIF PATCH_JPSSDL}
{$IFDEF PATCH_GH}
	,
	(	CmdName: 'ToggleSkipAnim';
		CmdDesc: 'Toggle Skip Animation.';
		KCode:	KBD_F9; )
	,
	(	CmdName: 'ForcePlot';
		CmdDesc: '';
		KCode:	'P'; )
	,
	(	CmdName: 'MechaPartBrowser';
		CmdDesc: '';
		KCode:	'!'; )
	,
	(	CmdName: 'ShowRep';
		CmdDesc: '';
		KCode:	'@'; )
	,
	(	CmdName: 'DirectScript';
		CmdDesc: '';
		KCode:	'#'; )
	,
	(	CmdName: 'WheelClick';
		CmdDesc: 'Do the key event when a mouse wheel is clicked.';
		KCode:	'5'; )
	,
	(	CmdName: 'WheelUp';
		CmdDesc: 'Do the key event when a mouse wheel is rolled to up.';
		KCode:	'['; )
	,
	(	CmdName: 'WheelDown';
		CmdDesc: 'Do the key event when a mouse wheel is rolled to down.';
		KCode:	']'; )
	,
	(	CmdName: 'WheelLeft';
		CmdDesc: 'Do the key event when a mouse wheel is rolled to left.';
		KCode:	'-'; )
	,
	(	CmdName: 'WheelRight';
		CmdDesc: 'Do the key event when a mouse wheel is rolled to right.';
		KCode:	'='; )
	,
	(	CmdName: 'WheelBack';
		CmdDesc: 'Do the key event when a mouse wheel is rolled to back.';
		KCode:	'-'; ),
	(	CmdName: 'WheelForward';
		CmdDesc: 'Do the key event when a mouse wheel is rolled to forward.';
		KCode:	'='; ),
	(	CmdName: 'Menu-Up';
		CmdDesc: 'Move up.';
		KCode: RPK_Up;	),
	(	CmdName: 'Menu-Down';
		CmdDesc: 'Move down.';
		KCode: RPK_Down;	),
	(	CmdName: 'Menu-Left';
		CmdDesc: 'Move left.';
		KCode: RPK_Left;	),
	(	CmdName: 'Menu-Right';
		CmdDesc: 'Move right.';
		KCode: RPK_Right;	),
	(	CmdName: 'Menu-PageUp';
		CmdDesc: 'Page up.';
		KCode: RPK_UpRight;	),
	(	CmdName: 'Menu-PageDown';
		CmdDesc: 'Page down.';
		KCode: RPK_DownRight;	),
	(	CmdName: 'Menu-ScrollUp';
		CmdDesc: 'Scroll Up.';
		KCode: RPK_UpLeft;	),
	(	CmdName: 'Menu-ScrollDown';
		CmdDesc: 'Scroll down.';
		KCode: RPK_DownLeft;	),
	(	CmdName: 'SearchParent';
		CmdDesc: 'Search Parent';
		KCode: '@';	),
	(	CmdName: 'SearchForward';
		CmdDesc: 'Search Forward';
		KCode: KBD_CTRL_F;	),
	(	CmdName: 'SearchBackward';
		CmdDesc: 'Search Backward';
		KCode: KBD_CTRL_B;	)
{$ENDIF PATCH_GH}
{$IFDEF PATCH_CHEAT}
	,
	(	CmdName: 'SelectPortrait';
		CmdDesc: '';
		KCode:	'/'; )
	,
	(	CmdName: 'RenameMecha';
		CmdDesc: '';
		KCode:	'@'; )
	,
	(	CmdName: 'EditMenuOrder';
		CmdDesc: '';
		KCode:	'\'; )
	,
	(	CmdName: 'Transformation';
		CmdDesc: 'Change form mode.';
		KCode: '*';	)
	,
	(	CmdName: 'PurgeParts';
		CmdDesc: 'Purge parts form mecha.';
		KCode: '*';	)
{$ENDIF PATCH_CHEAT}
{$IFDEF PATCH_HEART}
	,
	(	CmdName: 'AlwaysGPI';
		CmdDesc: 'Always GetPlayerInput';
		KCode:	'|'; )
{$ENDIF PATCH_HEART}
{IFDEF DEBUG}
	,
	(	CmdName: 'CanSeeAll';
		CmdDesc: '';
		KCode:	'~'; )
{ENDIF DEBUG}
	);

{$IFDEF PATCH_GH}
	KeyMapAliasMax = 9;

	KeyMapAlias: Array [1..KeyMapAliasMax] of KeyMapAliasDesc = (
  {$IFDEF SDLMODE}
	(	CmdAlias: 'Dir-UpLeft';		CmdName:  'Dir-West'; ),
	(	CmdAlias: 'Dir-Up';		CmdName:  'Dir-NorthWest'; ),
	(	CmdAlias: 'Dir-UpRight';	CmdName:  'Dir-North'; ),
	(	CmdAlias: 'Dir-Left';		CmdName:  'Dir-SouthWest'; ),
	(	CmdAlias: 'Dir-Right';		CmdName:  'Dir-NorthEast'; ),
	(	CmdAlias: 'Dir-DownLeft';	CmdName:  'Dir-South'; ),
	(	CmdAlias: 'Dir-Down';		CmdName:  'Dir-SouthEast'; ),
	(	CmdAlias: 'Dir-DownRight';	CmdName:  'Dir-East'; ),
  {$ELSE SDLMODE}
	(	CmdAlias: 'Dir-UpLeft';		CmdName:  'Dir-NorthWest'; ),
	(	CmdAlias: 'Dir-Up';		CmdName:  'Dir-North'; ),
	(	CmdAlias: 'Dir-UpRight';	CmdName:  'Dir-NorthEast'; ),
	(	CmdAlias: 'Dir-Left';		CmdName:  'Dir-West'; ),
	(	CmdAlias: 'Dir-Right';		CmdName:  'Dir-East'; ),
	(	CmdAlias: 'Dir-DownLeft';	CmdName:  'Dir-SouthWest'; ),
	(	CmdAlias: 'Dir-Down';		CmdName:  'Dir-South'; ),
	(	CmdAlias: 'Dir-DownRight';	CmdName:  'Dir-SouthEast'; ),
  {$ENDIF SDLMODE}
	( CmdAlias: ''; CmdName:  ''; )
	);
{$ENDIF PATCH_GH}
{$IFDEF PATCH_GH}
	KCodeAliasMax = 128;
	KCodeAlias: Array [1..(KCodeAliasMax+1)] of T_KCodeAlias = (
		( KCode_from: KBD_PgUp ; KCode_to: '9'      ; ),
		( KCode_from: KBD_Up   ; KCode_to: '8'      ; ),
		( KCode_from: KBD_Home ; KCode_to: '7'      ; ),
		( KCode_from: KBD_Left ; KCode_to: '4'      ; ),
		( KCode_from: KBD_Right; KCode_to: '6'      ; ),
		( KCode_from: KBD_PgDn ; KCode_to: '3'      ; ),
		( KCode_from: KBD_Down ; KCode_to: '2'      ; ),
		( KCode_from: KBD_End  ; KCode_to: '1'      ; ),
		( KCode_from: KBD_KP5  ; KCode_to: '5'      ; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; ),
		( KCode_from: KBD_ERROR; KCode_to: KBD_ERROR; )
	);
{$ENDIF PATCH_GH}

	{ *** KEYMAP COMMAND NUMBERS *** }
	KMC_NormSpeed = 1;
	KMC_FullSpeed = 2;
	KMC_TurnLeft = 3;
	KMC_TurnRight = 4;
	KMC_Stop = 5;
	KMC_SouthWest = 6;
	KMC_South = 7;
	KMC_SouthEast = 8;
	KMC_West = 9;
	KMC_East = 10;
	KMC_NorthWest = 11;
	KMC_North = 12;
	KMC_NorthEast = 13;
{$IFDEF PATCH_GH}
  {$IFDEF SDLMODE}
	KMC_UpLeft = 9;
	KMC_Up = 11;
	KMC_UpRight = 12;
	KMC_Left = 6;
	KMC_Right = 13;
	KMC_DownLeft = 7;
	KMC_Down = 8;
	KMC_DownRight = 10;
  {$ELSE SDLMODE}
	KMC_UpLeft = 11;
	KMC_Up = 12;
	KMC_UpRight = 13;
	KMC_Left = 9;
	KMC_Right = 10;
	KMC_DownLeft = 6;
	KMC_Down = 7;
	KMC_DownRight = 8;
  {$ENDIF SDLMODE}
{$ENDIF PATCH_GH}
	KMC_ShiftGears = 14;
	KMC_ExamineMap = 15;
	KMC_AttackMenu = 16;
	KMC_QuitGame = 17;
	KMC_Talk = 18;
	KMC_Help = 19;
	KMC_SwitchWeapon = 20;
	KMC_CalledShot = 21;
	KMC_Recenter = 22;
	KMC_Get = 23;
	KMC_Inventory = 24;
	KMC_Equipment = 25;
	KMC_Enter = 26;
	KMC_PartBrowser = 27;
	KMC_LearnSkills = 28;
	KMC_Attack = 29;
	KMC_UseProp = 30;
	KMC_ViewMemo = 31;
	KMC_SaveGame = 32;
	KMC_Enter2 = 33;
	KMC_CharInfo = 34;
	KMC_ApplySkill = 35;
	KMC_Eject = 36;
	KMC_Rest = 37;
	KMC_History = 38;
	KMC_FieldHQ = 39;
	KMC_Search = 40;
	KMC_Telephone = 41;
	KMC_SwitchBV = 42;
	KMC_Reverse = 43;
	KMC_SwitchTarget = 44;
	KMC_RunToggle = 45;
{$IFDEF ENABLE_ADDRESSBOOK}
	KMC_AddressBook = KMC_RunToggle + 1;
	KMC_AddressBook_NEXT = KMC_RunToggle + 2;
{$ELSE ENABLE_ADDRESSBOOK}
	KMC_AddressBook_NEXT = KMC_RunToggle + 1;
{$ENDIF ENABLE_ADDRESSBOOK}
{$IFDEF PATCH_JPSSDL}
	KMC_ToggleDrawWall = KMC_AddressBook_NEXT;
	KMC_ToggleDrawWall_NEXT = KMC_AddressBook_NEXT + 1;
{$ELSE PATCH_JPSSDL}
	KMC_ToggleDrawWall_NEXT = KMC_AddressBook_NEXT;
{$ENDIF PATCH_JPSSDL}
{$IFDEF PATCH_GH}
	KMC_ToggleSkipAnim   = KMC_ToggleDrawWall_NEXT;
	KMC_ForcePlot        = KMC_ToggleDrawWall_NEXT + 1;
	KMC_MechaPartBrowser = KMC_ToggleDrawWall_NEXT + 2;
	KMC_ShowRep          = KMC_ToggleDrawWall_NEXT + 3;
	KMC_DirectScript     = KMC_ToggleDrawWall_NEXT + 4;
	KMC_ButtonMiddle     = KMC_ToggleDrawWall_NEXT + 5;
	KMC_ButtonWUp        = KMC_ToggleDrawWall_NEXT + 6;
	KMC_ButtonWDown      = KMC_ToggleDrawWall_NEXT + 7;
	KMC_ButtonWLeft      = KMC_ToggleDrawWall_NEXT + 8;
	KMC_ButtonWRight     = KMC_ToggleDrawWall_NEXT + 9;
	KMC_ButtonWBack      = KMC_ToggleDrawWall_NEXT + 10;
	KMC_ButtonWForward   = KMC_ToggleDrawWall_NEXT + 11;
	KMC_MenuUp           = KMC_ToggleDrawWall_NEXT + 12;
	KMC_MenuDown         = KMC_ToggleDrawWall_NEXT + 13;
	KMC_MenuLeft         = KMC_ToggleDrawWall_NEXT + 14;
	KMC_MenuRight        = KMC_ToggleDrawWall_NEXT + 15;
	KMC_PageUp           = KMC_ToggleDrawWall_NEXT + 16;
	KMC_PageDown         = KMC_ToggleDrawWall_NEXT + 17;
	KMC_ScrollUp         = KMC_ToggleDrawWall_NEXT + 18;
	KMC_ScrollDown       = KMC_ToggleDrawWall_NEXT + 19;
	KMC_SearchParent     = KMC_ToggleDrawWall_NEXT + 20;
	KMC_SearchForward    = KMC_ToggleDrawWall_NEXT + 21;
	KMC_SearchBackward   = KMC_ToggleDrawWall_NEXT + 22;
	KMC_PATCH_GH_NEXT    = KMC_ToggleDrawWall_NEXT + 23;
{$ELSE PATCH_GH}
	KMC_PATCH_GH_NEXT = KMC_ToggleDrawWall_NEXT;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_CHEAT}
	KMC_SelectPortrait = KMC_PATCH_GH_NEXT;
	KMC_RenameMecha    = KMC_PATCH_GH_NEXT + 1;
	KMC_EditMenuOrder  = KMC_PATCH_GH_NEXT + 2;
	KMC_Transformation = KMC_PATCH_GH_NEXT + 3;
	KMC_PurgeParts     = KMC_PATCH_GH_NEXT + 4;
	KMC_PATCH_CHEAT_NEXT = KMC_PATCH_GH_NEXT + 5;
{$ELSE PATCH_CHEAT}
	KMC_PATCH_CHEAT_NEXT = KMC_PATCH_GH_NEXT;
{$ENDIF PATCH_CHEAT}
{$IFDEF PATCH_HEART}
	KMC_Always_GetPlayerInput = KMC_PATCH_CHEAT_NEXT;
	KMC_PATCH_HEART_NEXT = KMC_PATCH_CHEAT_NEXT + 1;
{$ELSE PATCH_HEART}
	KMC_PATCH_HEART_NEXT = KMC_PATCH_CHEAT_NEXT;
{$ENDIF PATCH_HEART}
{$IFDEF DEBUG}
	KMC_CanSeeAll  = KMC_PATCH_HEART_NEXT;
	KMC_DEBUG_NEXT = KMC_PATCH_HEART_NEXT + 1;
{$ELSE DEBUG}
	KMC_DEBUG_NEXT = KMC_PATCH_HEART_NEXT;
{$ENDIF DEBUG}

{$IFDEF PATCH_I18N}
  {$IF DEFINED(UNIX)}
	MaxFontSearchDirNum = 11;
	FontSearchDir: Array [1..MaxFontSearchDirNum] of String = (
		'',						{ Read from gharena.cfg }
		'Image',					{ default directory }
		'',						{ current directory }
		'/usr/local/share/fonts/gnu-unifont-ttf',	{ Failback Directory, FreeBSD 9.x and later }
		'/usr/local/share/fonts/OTF',			{ Failback Directory, FreeBSD 9.x and later }
		'/usr/local/share/fonts/TTF',			{ Failback Directory, FreeBSD 9.x and later }
		'/usr/local/lib/X11/fonts/TrueType',		{ Failback Directory, FreeBSD 6.3 and later }
		'/usr/X11R6/lib/X11/fonts/TrueType',		{ Failback Directory, FreeBSD 6.2 and before, some Distribution of GNU/Linux }
		'/usr/share/fonts/truetype/unifont',		{ Failback Directory, Debian GNU/Linux }
		'/usr/share/fonts/truetype/sazanami',		{ Failback Directory, Debian GNU/Linux }
		'/usr/share/fonts/opentype/ipafont-gothic'	{ Failback Directory, Debian GNU/Linux }
	);
	MaxFontSearchNameNum = 14;
	FontSearchName_Big: Array [1..MaxFontSearchNameNum] of FontSearchNameDesc = (
		(	{ Read from gharena.cfg }
			FontFile: '';
			FontFace: 0;
			FontSize: 14;
		), (	{ Read from GameData/I18N_settings.txt }
			FontFile: '';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 1 }
			FontFile: 'unifont.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 2 }
			FontFile: 'sazanami-gothic.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 3 }
			FontFile: 'sazanami-mincho.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 4 }
			FontFile: 'ipag.otf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 5 }
			FontFile: 'ipam.otf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 6 }
			FontFile: 'ipag.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 7 }
			FontFile: 'ipam.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 8 }
			FontFile: 'kochi-gothic-subst.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 9 }
			FontFile: 'kochi-mincho-subst.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 10 }
			FontFile: 'kochi-gothic.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 11 }
			FontFile: 'kochi-mincho.ttf';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, Default }
			FontFile: 'VeraBd.ttf';
			FontFace: 0;
			FontSize: 14;
		)
	);
	FontSearchName_Small: Array [1..MaxFontSearchNameNum] of FontSearchNameDesc = (
		(	{ Read from gharena.cfg }
			FontFile: '';
			FontFace: 0;
			FontSize: 11;
		), (	{ Read from GameData/I18N_settings.txt }
			FontFile: '';
			FontFace: 0;
			FontSize: 11;
		), (	{ Failback Font, 1 }
			FontFile: 'unifont.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 2 }
			FontFile: 'sazanami-gothic.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 3 }
			FontFile: 'sazanami-mincho.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 4 }
			FontFile: 'ipag.otf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 5 }
			FontFile: 'ipam.otf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 6 }
			FontFile: 'ipag.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 7 }
			FontFile: 'ipam.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 8 }
			FontFile: 'kochi-gothic-subst.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 9 }
			FontFile: 'kochi-mincho-subst.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 10 }
			FontFile: 'kochi-gothic.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 11 }
			FontFile: 'kochi-mincho.ttf';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, Default }
			FontFile: 'VeraMoBd.ttf';
			FontFace: 0;
			FontSize: 11;
		)
	);
  {$ELSEIF DEFINED(WINDOWS)}
	MaxFontSearchDirNum = 6;
	FontSearchDir: Array [1..MaxFontSearchDirNum] of String = (
		'',			{ Read from gharena.cfg }
		'Image',		{ default directory }
		'',			{ current directory }
		'',			{ Failback Directory, Read environment %windir% or %SystemRoot% }
		'C:\WINDOWS\Fonts',	{ Failback Directory, MS-Windows XP, MS-Windows 7, MS-Windows 8.1, Wine }
		'C:\WINNT\Fonts'	{ Failback Directory, MS-Windows 2000 }
	);
	MaxFontSearchNameNum = 6;
	FontSearchName_Big: Array [1..MaxFontSearchNameNum] of FontSearchNameDesc = (
		(	{ Read from gharena.cfg }
			FontFile: '';
			FontFace: 0;
			FontSize: 15;
		), (	{ Read from GameData/I18N_settings.txt }
			FontFile: '';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, 1 }
			FontFile: 'meiryo.ttc';
			FontFace: 0;
			FontSize: 12;
		), (	{ Failback Font, 2 }
			FontFile: 'msgothic.ttc';
			FontFace: 0;
			FontSize: 15;
		), (	{ Failback Font, 3 }
			FontFile: 'msmincho.ttc';
			FontFace: 0;
			FontSize: 15;
		), (	{ Failback Font, Default }
			FontFile: 'VeraBd.ttf';
			FontFace: 0;
			FontSize: 14;
		)
	);
	FontSearchName_Small: Array [1..MaxFontSearchNameNum] of FontSearchNameDesc = (
		(	{ Read from gharena.cfg }
			FontFile: '';
			FontFace: 0;
			FontSize: 13;
		), (	{ Read from GameData/I18N_settings.txt }
			FontFile: '';
			FontFace: 0;
			FontSize: 11;
		), (	{ Failback Font, 1 }
			FontFile: 'meiryo.ttc';
			FontFace: 0;
			FontSize: 9;
		), (	{ Failback Font, 2 }
			FontFile: 'msgothic.ttc';
			FontFace: 0;
			FontSize: 13;
		), (	{ Failback Font, 3 }
			FontFile: 'msmincho.ttc';
			FontFace: 0;
			FontSize: 13;
		), (	{ Failback Font, Default }
			FontFile: 'VeraMoBd.ttf';
			FontFace: 0;
			FontSize: 11;
		)
	);
  {$ELSE}
	MaxFontSearchDirNum = 3;
	FontSearchDir: Array [1..MaxFontSearchDirNum] of String = (
		'',			{ Read from gharena.cfg }
		'Image',		{ default directory }
		''			{ current directory }
	);
	MaxFontSearchNameNum = 3;
	FontSearchName_Big: Array [1..MaxFontSearchNameNum] of FontSearchNameDesc = (
		(	{ Read from gharena.cfg }
			FontFile: '';
			FontFace: 0;
			FontSize: 14;
		), (	{ Read from GameData/I18N_settings.txt }
			FontFile: '';
			FontFace: 0;
			FontSize: 14;
		), (	{ Failback Font, Default }
			FontFile: 'VeraBd.ttf';
			FontFace: 0;
			FontSize: 14;
		)
	);
	FontSearchName_Small: Array [1..MaxFontSearchNameNum] of FontSearchNameDesc = (
		(	{ Read from gharena.cfg }
			FontFile: '';
			FontFace: 0;
			FontSize: 11;
		), (	{ Read from GameData/I18N_settings.txt }
			FontFile: '';
			FontFace: 0;
			FontSize: 11;
		), (	{ Default font }
			FontFile: 'VeraMoBd.ttf';
			FontFace: 0;
			FontSize: 11;
		)
	);
  {$ENDIF}

	FontSize_Big: Integer = 0;
	FontSize_Small: Integer = 0;
	{ PATCH_I18N: Converted by Load_I18N_Default }
	ProhibitationHead  : String = '! ) , . > ? ] }';
	ProhibitationTrail : String = '( < [ {';
{$ENDIF PATCH_I18N}
{$IF DEFINED(WINDOWS)}
{$ELSE}
	MSWINGUI_FontName: String = 'Terminal';
	MSWINGUI_FontWeight: Integer = 0;
	MSWINGUI_FontSize: Integer = 15;
{$ENDIF}
{$IFDEF PATCH_I18N}
	I18N_UseNameORG : Boolean = False;
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_JPSSDL}
	Pad_Left : Integer = 0;
	Pad_Top  : Integer = 0;
	SkipAnim : Boolean = False;
	DrawWallMode : Integer = 1;
{$ENDIF PATCH_JPSSDL}
{$IFDEF PATCH_HEART}
	KeyWait : Integer = 100;
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_GH}
	SDL_Accelerated : Boolean = False;
	SDL_PresentVsync : Boolean = False;
  {$IFDEF SDL2}
	SDL_RendererMode : UInt32 = SDL_RENDERER_SOFTWARE;
  {$ELSE SDL2}
  {$ENDIF SDL2}
	SDL_NoTimeEvent : Boolean = False;
	FrameSkip : Boolean = True;
	FrameInterval : Integer = 33;
	SleepGranularity : Integer = 0;
	KeysamplingInterval  : Integer = 11;
	SDL_Mini : Boolean = False;
	ScreenPos_X: Integer = -1;
	ScreenPos_Y: Integer = -1;
var
	ScreenSize_Width  : Integer;
	ScreenSize_Height : Integer;
	CUI_ScreenSize_Width  : Integer;
	CUI_ScreenSize_Height : Integer;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
var
	QRLViewer_ScreenSize_Width  : Integer;
	QRLViewer_ScreenSize_Height : Integer;
	QRLViewer_ScreenPos_X : Integer;
	QRLViewer_ScreenPos_Y : Integer;
{$ENDIF PATCH_HEART}
const
{$IFDEF PATCH_I18N}
  {IFDEF SDLMODE}
	SDL_AAFont        : Boolean = False;
	SDL_AAFont_Shaded : Boolean = False;
  {ENDIF SDLMODE}
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
  {$IF DEFINED(SDLMODE)}
  {$ELSEIF DEFINED(ASCII_SDL)}
  {$ELSE}
type
	PSDL_Color = ^TSDL_Color;
	TSDL_Color = record
		r: Byte;
		g: Byte;
		b: Byte;
	end;
const
  {$ENDIF}
  {IFDEF SDLMODE}
	{ for Color Barrier Free }
	StdBlack: TSDL_Color =		( r:  0; g:  0; b:  0 );
	StdWhite: TSDL_Color =		( r:255; g:255; b:255 );
	MenuItem: TSDL_Color =		( r: 90; g:156; b:179 );
	MenuSelect: TSDL_Color =	( r:128; g:255; b:230 );
	PlayerBlue: TSDL_Color =	( r:  0; g:141; b:211 );
	AllyPurple: TSDL_Color =	( r:236; g:  0; b:211 );
	EnemyRed: TSDL_Color =		( r:230; g:  0; b:  0 );
	NeutralGrey: TSDL_Color =	( r:150; g:150; b:150 );
	DarkGrey: TSDL_Color =		( r:100; g:100; b:100 );
	InfoGreen: TSDL_Color =		( r: 50; g:200; b:  0 );
	InfoHiLight: TSDL_Color =	( r:100; g:250; b:  0 );
	TextboxGrey: TSDL_Color =	( r:130; g:120; b:125 );
	NeutralBrown: TSDL_Color =	( r:240; g:201; b: 20 );
	BorderBlue: TSDL_Color =	( r:  0; g:101; b:151 );
	BrightYellow: TSDL_Color =	( r:255; g:201; b:  0 );
	{ sdlinfo.pp }
	StatusPerfect:TSDL_Color =	( r:  0; g:255; b: 65 );
	StatusOK:TSDL_Color =		( r: 30; g:190; b: 10 );
	StatusFair:TSDL_Color =		( r:220; g:190; b:  0 );
	StatusBad:TSDL_Color =		( r:220; g: 50; b:  0 );
	StatusCritical:TSDL_Color =	( r:150; g:  0; b:  0 );
	StatusKO:TSDL_Color =		( r: 75; g: 75; b: 75 );
  {ENDIF SDLMODE}
	MaxSDLColors_Str = 64;
	SDL_colors_TeamColor_Character_DefPlayerTeam : Array [0..MaxSDLColors_Str] of Char = ' 66 121 179';
	SDL_colors_TeamColor_Character_Enemies       : Array [0..MaxSDLColors_Str] of Char = '180  10 120';
	SDL_colors_TeamColor_Character_Allies        : Array [0..MaxSDLColors_Str] of Char = ' 66 121 119';
	SDL_colors_TeamColor_Character_Others        : Array [0..MaxSDLColors_Str] of Char = '175 175 171';
	SDL_colors_TeamColor_Mecha_DefPlayerTeam     : Array [0..MaxSDLColors_Str] of Char = ' 66 121 179 210 215  80 205  25   0';
	SDL_colors_TeamColor_Mecha_Enemies           : Array [0..MaxSDLColors_Str] of Char = '180  10 120 125 125 125 170 205  75';
	SDL_colors_TeamColor_Mecha_Allies            : Array [0..MaxSDLColors_Str] of Char = ' 66 121 119 190 190 190   0 205   0';
	SDL_colors_TeamColor_Mecha_Others            : Array [0..MaxSDLColors_Str] of Char = '175 175 171 100 100 120   0 200 200';
	SDL_colors_RobotCreate                       : Array [0..MaxSDLColors_Str] of Char = ' 80  80  85 170 155 230   6  42 120';
	SDL_colors_CharacterCreate                   : Array [0..MaxSDLColors_Str] of Char = ' 49  91 161 252 212 195 150 112  89';
	Enable_ArenaMode : Boolean = True;
	Enable_EditMap   : Boolean = True;
	Enable_PointAnimation : Boolean = False;
	Enable_MouseClick_OutsideTheMenuArea : Boolean = False;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_l0ugh}
	KeyBind_RogueMove: Boolean = False;
{$ENDIF PATCH_l0ugh}
{$IFDEF PATCH_GH}
	SelectMenu_Scroll_by_Edge: Boolean = True;
	Show_MenuScrollbar : Boolean = False;
  {IFDEF SDLMODE}
	SDL_Show_MenuScrollbar : Boolean = False;
	SDL_Scrollbar_Size : Integer = 12;
	SDL_Change_DialogHeight : Integer = 8;
  {ENDIF SDLMODE}
	Show_MenuPage : Boolean = False;
	Cheat_DisplayGearInfo : Boolean = False;
	Cheat_Display_MemoNumber : Boolean = False;
	Cheat_ASCII_Display_CharacterDisplay : Boolean = False;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_CHEAT}
	Cheat_Display : Boolean = False;
	Cheat_Display_SW : Boolean = False;
	Cheat_Display_DESIG : Boolean = False;
	Cheat_Display_OverLoad : Boolean = False;
	Cheat_Display_DamagePercent : Boolean = False;
	Cheat_Display_SpeedoMeter : Boolean = False;
	Cheat_Display_PV : Boolean = False;
	Cheat_Show_Always_ExtendedDescription : Boolean = False;
	Cheat_Show_SF : Boolean = False;
	Cheat_Show_Size : Boolean = False;
	Cheat_Show_PV : Boolean = False;
	Cheat_Print_TimeString : Boolean = False;
	Cheat_Print_AttemptDefenses : Boolean = False;
	Cheat_Print_AmmoExplosion : Boolean = False;
	Cheat_Print_DoPillage : Boolean = False;
	Cheat_Print_Drain_MaxHP : Boolean = False;
	Cheat_Autosave_Trace : Boolean = False;
	Cheat_Autosave_with_Timestamp : Boolean = False;
	Cheat_MainMenu_AddMenuKey : Boolean = False;
	Cheat_Restore_AddMenuKey : Boolean = False;
	Cheat_Chat : Boolean = False;
	Cheat_Chat_ReverseSort : Boolean = False;
	Cheat_CallShot : Boolean = False;
	Cheat_CallShot_Cancel : Boolean = False;
	Cheat_CallShot_OmitLookInfo : Boolean = False;
	Cheat_Range_Colored : Boolean = False;
	Cheat_Range_with_Altitude : Boolean = False;
	Cheat_MenuOrder_Edit : Boolean = False;
	Cheat_MechaPartBrowser_Delete : Boolean = False;
	Cheat_NPC_Edit : Boolean = False;
	Cheat_Unlimited_Sprite : Boolean = False;
	Cheat_Unlimited_Portrait : Boolean = False;
	Cheat_LookInfo : Boolean = False;
	Cheat_Enable_Limit_SellingPrice : Boolean = False;
	Cheat_BuyStuff_ShowSubItem : Boolean = False;
	Cheat_BuyStuff_Mecha_ShowSubItem : Boolean = False;
	Cheat_BuyStuff_Sort : Boolean = True;
	Cheat_SellStuff_ShowSubItem : Boolean = False;
	Cheat_SellStuff_Sort : Boolean = False;
	Cheat_SellStuff_KeepPosition : Boolean = False;
	Cheat_EqpMenu_AddMenuKey : Boolean = False;
	Cheat_EqpMenu_KeepPosition : Boolean = False;
	Cheat_EqpMenu_ShowSubItem : Boolean = False;
	Cheat_EqpMenu_ShowMassMeter : Boolean = False;
	Cheat_EqpMenu_ShowFullGearName : Boolean = False;
	Cheat_InvMenu_KeepPosition : Boolean = False;
	Cheat_InvMenu_ShowSubItem : Boolean = False;
	Cheat_InvMenu_NoSort : Boolean = False;
	Cheat_Show_ComponentMass : Boolean = False;
	Cheat_MechaDescription_ShowMassMeter : Boolean = False;
	Cheat_MechaPartEditor_AddMenuKey : Boolean = True;
	Cheat_MechaPartEditor_KeepPosition : Boolean = True;
	Cheat_PCVIEW_Training_AddMenuKey : Boolean = False;
	Cheat_PCVIEW_Training_KeepPosition : Boolean = False;
	Cheat_FieldHQ_Mecha_NoSort : Boolean = False;
	Cheat_FieldHQ_Mecha_KeepPosition : Boolean = False;
	Cheat_FieldHQ_AddMenuKey : Boolean = False;
	Cheat_InstallMisc_ShowParentItem : Boolean = False;
	Cheat_EquipItem_ShowParentItem : Boolean = False;
	Cheat_InstallMisc_ShowInvStr : Boolean = False;
	Cheat_EquipItem_ShowInvStr : Boolean = False;
	Cheat_InstallAmmo_ShowSubItem : Boolean = False;
	Cheat_EquipItem_ShowSubItem : Boolean = False;
	Cheat_Install_ShowSubItem : Boolean = False;
	Cheat_InstallCyberware_ShowSubItem : Boolean = False;
	Cheat_ExtendedDescription_ShowHighOutput : Boolean = False;
	Cheat_GearName_AddScaleNumber : Boolean = False;
	Cheat_GearName_AddClassNumber_GGModule : Boolean = False;
	Cheat_GearName_AddClassNumber_GGMecha : Boolean = False;
	Cheat_GearName_AddClassNumber_GGHolder : Boolean = False;
	Cheat_GearName_AddClassNumber_GGSupport : Boolean = False;
	Cheat_GearName_AddClassNumber_GGConsumable : Boolean = False;
	Cheat_MechaCustomize_Limitless : Boolean = False;
	Cheat_MechaCustomize_FreeSupport : Boolean = False;
	Cheat_MechaCustomize_FreeCockpit : Boolean = False;
	Cheat_MechaCustomize_FreeMasterGear : Boolean = False;
	Cheat_MechaCustomize_FreeParent : Boolean = False;
	Cheat_MechaCustomize_FreeScale : Boolean = False;
	Cheat_MechaCustomize_FreeModifier : Boolean = False;
	Cheat_MechaCustomize_FreeBodyModule : Boolean = False;
	Cheat_MechaCustomize_FreeIntegral : Boolean = False;
	Cheat_Trade_NotSafeArea : Boolean = False;
	Cheat_Trade_LanceMateMenuName : Boolean = False;
	Cheat_Roguelike_Death : Boolean = False;
	Cheat_ArenaMode_MainMenu_AddMenuKey : Boolean = False;
	Cheat_ArenaMode_PilotsMenu_AddMenuKey : Boolean = False;
	Cheat_ArenaMode_MechaMenu_AddMenuKey : Boolean = False;
	Cheat_ArenaMode_PilotsHQ_AddMenuKey : Boolean = False;
	Cheat_ArenaMode_MechaHQ_AddMenuKey : Boolean = False;
	Cheat_ArenaMode_AllRecoveryInHQ : Boolean = False;
	Cheat_ArenaMode_InventoryInHQ : Boolean = False;
	Cheat_ArenaMode_FieldHQInHQ : Boolean = False;
	Cheat_ArenaMode_MapSelect : Boolean = False;
	Cheat_ThisItemWasSelected_AddMenuKey : Boolean = False;
	Cheat_EnableCockpitBarrier : Boolean = True;
	Cheat_EnableCockpitBarrier_Hand : Boolean = True;
	Cheat_DoNotRunWhenMouseClicked : Boolean = True;
	Cheat_DoNotTargetMaterial : Boolean = False;
	Cheat_Enable_SubInvMenu : Boolean = False;
	Cheat_NPConMechaWillRepair : Boolean = False;
	Cheat_Avoid_Zombie : Boolean = True;
	Cheat_NPC_AvoidAttackToNeutrality : Boolean = False;
	Cheat_NPC_UseGrenade : Boolean = False;
	Cheat_DoNotRoundUp_ARP : Boolean = False;
	Cheat_ReloadAllMecha : Boolean = False;
	Cheat_Show_WeaponRecharge : Boolean = False;
	Cheat_Fix_SolveLine : Boolean = False;
	Cheat_Show_RangeCover : Boolean = False;
	Cheat_SelectSprite : Boolean = False;
	Cheat_Show_NeedHand : Boolean = False;
{$ENDIF PATCH_CHEAT}
{$IFDEF PATCH_HEART}
	Cheat_Always_GetPlayerInput : Boolean = False;
	DEBUG_EnableLuaDebugger : Boolean = False;
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_BACKPORT}
	Backport_Caliber : Boolean = False;
	Backport_Caliber_GH1Compatible : Boolean = True;
{$ENDIF PATCH_BACKPORT}
{$IFDEF PATCH_GH}
  {IFDEF DEBUG}
{	DEBUG_MemoryLeak : Boolean = True; }
	DEBUG_TraceMacro : Boolean = True;
	DEBUG_Grabbed_Gear : Boolean = True;
	DEBUG_SCRIPT_DynamicEncounter : Boolean = True;
{	DEBUG_DONOT_NIL_Grabbed_Gear_when_NewGear                    : Boolean = False; }
{	DEBUG_DONOT_NIL_Grabbed_Gear_when_DisposeGear                : Boolean = False; }
	DEBUG_DONOT_NIL_Grabbed_Gear_when_DelegeGG                   : Boolean = False;
	DEBUG_DONOT_NIL_Grabbed_Gear_when_EndStory                   : Boolean = False;
	DEBUG_DONOT_NIL_Grabbed_Gear_when_CleanupStoryPlots          : Boolean = False;
{	DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_AbsolutelyNothing : Boolean = False; }
{	DEBUG_DONOT_NIL_Grabbed_Gear_when_Mark_GG_DisposeGear        : Boolean = False; }
{	DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_DisposeGear       : Boolean = False; }
	DEBUG_DONOT_NIL_Grabbed_Gear_when_Change_Scene               : Boolean = False;
	DEBUG_DONOT_NIL_SCRIPT_DynamicEncounter                      : Boolean = False;
	DEBUG_FORCE_EXEC_MacroUPDATE_when_Restore      : Boolean = False;
	DEBUG_FORCE_EXEC_MacroSTART_when_Restore       : Boolean = False;
	DEBUG_STOP_MacroRESTORESTART_when_Restore      : Boolean = False;
	DEBUG_FORCE_RestockRandomMonsters_when_Restore : Boolean = False;
	DEBUG_MaxCID : Boolean = True;
	DEBUG_MaxNID : Boolean = True;
	DEBUG_CanSeeAll : Boolean = False;
    {$IFDEF PATCH_HEART}
	DEBUG_TraceQRL : Boolean = True;
    {$ENDIF PATCH_HEART}
  {ENDIF DEBUG}
{$ENDIF PATCH_GH}


{$IFDEF PATCH_GH}
Function KeyMapEncode( const header: String; const src: Char ): String;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_I18N}
Function I18N_Help_Keymap_Name_String( const MsgLabel: String ): String;
Function I18N_Help_Keymap_Desc_String( const MsgLabel: String ): String;
{$ENDIF PATCH_I18N}


implementation

uses
{$IFDEF PATCH_GH}
{ "sysutils" has to come before others. }
	sysutils,
{$ELSE PATCH_GH}
  {$IFDEF PATCH_I18N}
	sysutils,
  {$ENDIF PATCH_I18N}
{$ENDIF PATCH_GH}
	dos,
{$IFDEF PATCH_GH}
	errmsg,
{$ELSE PATCH_GH}
  {$IFDEF DEBUG}
	errmsg,
  {$ENDIF DEBUG}
{$ENDIF PATCH_GH}
{$IFDEF PATCH_GH}
	pseudosmartpointer,
{$ENDIF PATCH_GH}
{$IFDEF PATCH_I18N}
	i18nmsg,
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
	gears_base,
	gears,
	texutil
{$ELSE PATCH_GH}
	ability,
	gears,
	texutil
{$ENDIF PATCH_GH}
{$IF DEFINED(WINDOWS)}
	,w32
{$ENDIF}
	;


{$IFDEF PATCH_GH}
  {IFDEF SDLMODE}
type
	T_KCodeName = Record
		KCodeName: String;
		KCode: Char;
	end;

	T_ColorTable = Record
		Name: String;
		DataPtr: PSDL_Color;
	end;
	T_SDLColorTable = Record
		Name: String;
		DataPtr: PChar;
	end;

const
	KCodeName: Array [1..68] of T_KCodeName = (
		( KCodeName: 'F1';	KCode: KBD_F1; ),
		( KCodeName: 'F2';	KCode: KBD_F2; ),
		( KCodeName: 'F3';	KCode: KBD_F3; ),
		( KCodeName: 'F4';	KCode: KBD_F4; ),
		( KCodeName: 'F5';	KCode: KBD_F5; ),
		( KCodeName: 'F6';	KCode: KBD_F6; ),
		( KCodeName: 'F7';	KCode: KBD_F7; ),
		( KCodeName: 'F8';	KCode: KBD_F8; ),
		( KCodeName: 'F9';	KCode: KBD_F9; ),
		( KCodeName: 'F10';	KCode: KBD_F10; ),
		( KCodeName: 'F11';	KCode: KBD_F11; ),
		( KCodeName: 'F12';	KCode: KBD_F12; ),
		( KCodeName: 'F13';	KCode: KBD_F13; ),
		( KCodeName: 'F14';	KCode: KBD_F14; ),
		( KCodeName: 'F15';	KCode: KBD_F15; ),
		( KCodeName: 'F16';	KCode: KBD_F16; ),
		( KCodeName: 'F17';	KCode: KBD_F17; ),
		( KCodeName: 'F18';	KCode: KBD_F18; ),
		( KCodeName: 'F19';	KCode: KBD_F19; ),
		( KCodeName: 'F20';	KCode: KBD_F20; ),
		( KCodeName: 'LWin';	KCode: KBD_LWin; ),
		( KCodeName: 'RWin';	KCode: KBD_RWin; ),
		( KCodeName: 'Apps';	KCode: KBD_Apps; ),
		( KCodeName: 'Home';	KCode: KBD_Home; ),
		( KCodeName: 'Up';	KCode: KBD_Up; ),
		( KCodeName: 'PgUp';	KCode: KBD_PgUp; ),
		( KCodeName: 'Left';	KCode: KBD_Left; ),
		( KCodeName: 'Middle';	KCode: KBD_KP5; ),
		( KCodeName: 'Right';	KCode: KBD_Right; ),
		( KCodeName: 'End';	KCode: KBD_End; ),
		( KCodeName: 'Down';	KCode: KBD_Down; ),
		( KCodeName: 'PgDn';	KCode: KBD_PgDn; ),
		( KCodeName: 'Insert';	KCode: KBD_Insert; ),
		( KCodeName: 'Delete';	KCode: KBD_Delete; ),
		( KCodeName: 'Backspace';	KCode: KBD_BS; ),
		( KCodeName: 'Tab';		KCode: KBD_TAB; ),
		( KCodeName: 'Return';		KCode: KBD_RET; ),
		( KCodeName: 'ESC';		KCode: KBD_ESC; ),
		( KCodeName: 'Space';	KCode: ' '; ),
		( KCodeName: 'Ctrl_a';	KCode: KBD_CTRL_A; ),
		( KCodeName: 'Ctrl_b';	KCode: KBD_CTRL_B; ),
		( KCodeName: 'Ctrl_c';	KCode: KBD_CTRL_C; ),
		( KCodeName: 'Ctrl_d';	KCode: KBD_CTRL_D; ),
		( KCodeName: 'Ctrl_e';	KCode: KBD_CTRL_E; ),
		( KCodeName: 'Ctrl_f';	KCode: KBD_CTRL_F; ),
		( KCodeName: 'Ctrl_g';	KCode: KBD_CTRL_G; ),
		( KCodeName: 'Ctrl_h';	KCode: KBD_CTRL_H; ),
		( KCodeName: 'Ctrl_i';	KCode: KBD_CTRL_I; ),
		( KCodeName: 'Ctrl_j';	KCode: KBD_CTRL_J; ),
		( KCodeName: 'Ctrl_k';	KCode: KBD_CTRL_K; ),
		( KCodeName: 'Ctrl_l';	KCode: KBD_CTRL_L; ),
		( KCodeName: 'Ctrl_m';	KCode: KBD_CTRL_M; ),
		( KCodeName: 'Ctrl_n';	KCode: KBD_CTRL_N; ),
		( KCodeName: 'Ctrl_o';	KCode: KBD_CTRL_O; ),
		( KCodeName: 'Ctrl_p';	KCode: KBD_CTRL_P; ),
		( KCodeName: 'Ctrl_q';	KCode: KBD_CTRL_Q; ),
		( KCodeName: 'Ctrl_r';	KCode: KBD_CTRL_R; ),
		( KCodeName: 'Ctrl_s';	KCode: KBD_CTRL_S; ),
		( KCodeName: 'Ctrl_t';	KCode: KBD_CTRL_T; ),
		( KCodeName: 'Ctrl_u';	KCode: KBD_CTRL_U; ),
		( KCodeName: 'Ctrl_v';	KCode: KBD_CTRL_V; ),
		( KCodeName: 'Ctrl_w';	KCode: KBD_CTRL_W; ),
		( KCodeName: 'Ctrl_x';	KCode: KBD_CTRL_X; ),
		( KCodeName: 'Ctrl_y';	KCode: KBD_CTRL_Y; ),
		( KCodeName: 'Ctrl_z';	KCode: KBD_CTRL_Z; ),
		( KCodeName: 'none';	KCode: KBD_NONE; ),
		( KCodeName: 'error';	KCode: KBD_ERROR; ),
		( KCodeName: '';	KCode: KBD_ERROR; )
	);

	ColorTable_Num = 21;
	ColorTable: Array [1..ColorTable_Num] of T_ColorTable = (
	(	Name: 'StdBlack';		DataPtr: @StdBlack;	),
	(	Name: 'StdWhite';		DataPtr: @StdWhite;	),
	(	Name: 'MenuItem';		DataPtr: @MenuItem;	),
	(	Name: 'MenuSelect';		DataPtr: @MenuSelect;	),
	(	Name: 'PlayerBlue';		DataPtr: @PlayerBlue;	),
	(	Name: 'AllyPurple';		DataPtr: @AllyPurple;	),
	(	Name: 'EnemyRed';		DataPtr: @EnemyRed;	),
	(	Name: 'NeutralGrey';		DataPtr: @NeutralGrey;	),
	(	Name: 'DarkGrey';		DataPtr: @DarkGrey;	),
	(	Name: 'InfoGreen';		DataPtr: @InfoGreen;	),
	(	Name: 'InfoHiLight';		DataPtr: @InfoHiLight;	),
	(	Name: 'TextboxGrey';		DataPtr: @TextboxGrey;	),
	(	Name: 'NeutralBrown';		DataPtr: @NeutralBrown;	),
	(	Name: 'BorderBlue';		DataPtr: @BorderBlue;	),
	(	Name: 'BrightYellow';		DataPtr: @BrightYellow;	),
	(	Name: 'StatusPerfect';		DataPtr: @StatusPerfect;	),
	(	Name: 'StatusOK';		DataPtr: @StatusOK;		),
	(	Name: 'StatusFair';		DataPtr: @StatusFair;		),
	(	Name: 'StatusBad';		DataPtr: @StatusBad;		),
	(	Name: 'StatusCritical';		DataPtr: @StatusCritical;	),
	(	Name: 'StatusKO';		DataPtr: @StatusKO;		)
	);

	SDLColorTable_Num = 10;
	SDLColorTable: Array [1..SDLColorTable_Num] of T_SDLColorTable = (
	(	Name: 'TeamColor_Character_DefPlayerTeam';	DataPtr: @SDL_colors_TeamColor_Character_DefPlayerTeam;		),
	(	Name: 'TeamColor_Character_Enemies';		DataPtr: @SDL_colors_TeamColor_Character_Enemies      ;		),
	(	Name: 'TeamColor_Character_Allies';		DataPtr: @SDL_colors_TeamColor_Character_Allies       ;		),
	(	Name: 'TeamColor_Character_Others';		DataPtr: @SDL_colors_TeamColor_Character_Others       ;		),
	(	Name: 'TeamColor_Mecha_DefPlayerTeam';		DataPtr: @SDL_colors_TeamColor_Mecha_DefPlayerTeam    ;		),
	(	Name: 'TeamColor_Mecha_Enemies';		DataPtr: @SDL_colors_TeamColor_Mecha_Enemies          ;		),
	(	Name: 'TeamColor_Mecha_Allies';			DataPtr: @SDL_colors_TeamColor_Mecha_Allies           ;		),
	(	Name: 'TeamColor_Mecha_Others';			DataPtr: @SDL_colors_TeamColor_Mecha_Others           ;		),
	(	Name: 'RobotCreate';		DataPtr: @SDL_colors_RobotCreate;		),
	(	Name: 'CharacterCreate';	DataPtr: @SDL_colors_CharacterCreate;		)
	);
  {ENDIF SDLMODE}
{$ENDIF PATCH_GH}

{$IF DEFINED(PATCH_I18N) or DEFINED(PATCH_GH)}
var
{$ENDIF DEFINED(PATCH_I18N) or DEFINED(PATCH_GH)}
{$IFDEF PATCH_I18N}
	I18N_Help_Keymap_Name: SAttPtr;
	I18N_Help_Keymap_Desc: SAttPtr;
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
	Use_KeyMapAlias: Boolean = true;
{$ENDIF PATCH_GH}


{$IFDEF PATCH_GH}
Function KeyMapEncode( const header: String; const src: Char ): String;
const
	AllowableCharacters = '!"#$%&()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~';
var
	c: Char;
	i: Integer;
begin
	c := KBD_ERROR;
	if (KBD_NONE < src) and (src < KBD_UNICODE_FLAG) then begin
		c := src;
	end;
	if ( 0 < Pos(c, AllowableCharacters) ) then begin
		KeyMapEncode := c;
	end else begin
		KeyMapEncode := '#' + BStr( Ord(src) );
		i := 1;
		while ( 0 < Length(KCodeName[i].KCodeName) ) do begin
			if ( KCodeName[i].KCode = src ) then begin
				KeyMapEncode := header + KCodeName[i].KCodeName;
				break;
			end;
			Inc( i );
		end;
	end;
end;
{$ENDIF PATCH_GH}

{$IFDEF PATCH_I18N}
Function I18N_Help_Keymap_Name_String( const MsgLabel: String ): String;
begin
	I18N_Help_Keymap_Name_String := SAttValue( I18N_Help_Keymap_Name, MsgLabel );
end;

Function I18N_Help_Keymap_Desc_String( const MsgLabel: String ): String;
begin
	I18N_Help_Keymap_Desc_String := SAttValue( I18N_Help_Keymap_Desc, MsgLabel );
end;

Procedure Load_I18N_Default;
begin
	{ ControlTypeName[0] := I18N_MsgString('ui4gh_ControlTypeName','Menu'); }
	{ ControlTypeName[1] := I18N_MsgString('ui4gh_ControlTypeName','Roguelike'); }
	BVTypeName[1]      := I18N_MsgString('ui4gh','BVTypeName1');
	BVTypeName[2]      := I18N_MsgString('ui4gh','BVTypeName2');
	BVTypeName[3]      := I18N_MsgString('ui4gh','BVTypeName3');
	BVTypeName[4]      := I18N_MsgString('ui4gh','BVTypeName4');
	ProhibitationHead                := I18N_Settings('ProhibitationHead',ProhibitationHead);
	ProhibitationTrail               := I18N_Settings('ProhibitationTrail',ProhibitationTrail);
	FontSearchName_Big[2].FontFile   := I18N_Settings('Default_FontFileBig',FontSearchName_Big[2].FontFile);
	FontSearchName_Big[2].FontFace   := StrToInt(I18N_Settings('Default_FontFaceBig',IntToStr(FontSearchName_Big[2].FontFace)));
	FontSearchName_Big[2].FontSize   := StrToInt(I18N_Settings('Default_FontSizeBig',IntToStr(FontSearchName_Big[2].FontSize)));
	FontSearchName_Small[2].FontFile := I18N_Settings('Default_FontFileSmall',FontSearchName_Small[2].FontFile);
	FontSearchName_Small[2].FontFace := StrToInt(I18N_Settings('Default_FontFaceSmall',IntToStr(FontSearchName_Small[2].FontFace)));
	FontSearchName_Small[2].FontSize := StrToInt(I18N_Settings('Default_FontSizeSmall',IntToStr(FontSearchName_Small[2].FontSize)));
  {IF DEFINED(WINDOWS)}
	MSWINGUI_FontName                := I18N_Settings('MSWIN_Default_FontNameOther',MSWINGUI_FontName);
	MSWINGUI_FontWeight              := StrToInt(I18N_Settings('MSWIN_Default_FontWeightOther',IntToStr(MSWINGUI_FontWeight)));
	MSWINGUI_FontSize                := StrToInt(I18N_Settings('MSWIN_Default_FontSizeOther',IntToStr(MSWINGUI_FontSize)));
  {ENDIF}
end;
{$ENDIF PATCH_I18N}


	Procedure LoadConfig;
		{ Open the configuration file and set the variables }
		{ as needed. }
{$IFDEF PATCH_GH}
		Function KeyMapDecode( const src: String ): Char;
		var
			i: Integer;
			s: String;
			ret: Boolean;
		begin
			KeyMapDecode := KBD_ERROR;
			if (Length(src) < 1) then begin
				ErrorMessage_fork('ERROR: KeyName not found.');
			end else if (1 = Length(src)) then begin
				KeyMapDecode := src[1];
			end else if ('#' = src[1]) and (2 <= Length(src)) then begin
				ret := False;
				s := Copy(src,2,Length(src)-1);
				i := 1;
				while ( 0 < Length(KCodeName[i].KCodeName) ) do begin
					if ( UpCase(KCodeName[i].KCodeName) = UpCase(s) ) then begin
						KeyMapDecode := KCodeName[i].KCode;
						ret := True;
					end;
					Inc( i );
				end;
				if not ret then begin
					ErrorMessage_fork('ERROR: Unknown KeyName : ' + src);
				end;
			end else begin
				ErrorMessage_fork('ERROR: Unknown KeyName : ' + src);
			end;
		end;
{$ENDIF PATCH_GH}
	var
		F: Text;
		S,CMD,C: String;
		T: Integer;
{$IFDEF PATCH_I18N}
  {$IF DEFINED(WINDOWS)}
		WinDir: String;
  {$ENDIF}
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
		Done: Boolean;
		KCode_from_tmp: Char;
		KCode_to_tmp: Char;
		ColorNum: Integer;
		KCodeAlias_ptr: Integer;
{$ENDIF PATCH_GH}
	begin
{$IFDEF PATCH_GH}
		KCodeAlias_ptr := 1;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_I18N}
  {$IF DEFINED(WINDOWS)}
		WinDir := '';
		if '' = WinDir then begin
			WinDir := GetEnvironmentVariable('SystemRoot');
		end;
		if '' = WinDir then begin
			WinDir := GetEnvironmentVariable('windir');
		end;
		if '' <> WinDir then begin
			FontSearchDir[4] := WinDir + DirectorySeparator + 'Fonts';
		end;
  {$ENDIF}
{$ENDIF PATCH_I18N}
		{See whether or not there's a configuration file.}
		S := FSearch(Config_File,'.');
		if S <> '' then begin
			{ If we've found a configuration file, }
			{ open it up and start reading. }
			Assign(F,S);
			Reset(F);
{$IFDEF PATCH_GH}
			KCodeAlias[KCodeAlias_ptr].KCode_from := KBD_ERROR;
{$ENDIF PATCH_GH}

			while not Eof(F) do begin
				ReadLn(F,S);
				cmd := ExtractWord(S);
				if (cmd <> '') then begin
{$IFDEF PATCH_GH}
					Done := False;
{$ENDIF PATCH_GH}
					{Check to see if CMD is one of the standard keys.}
					cmd := UpCase(cmd);
{$IFDEF PATCH_GH}
					for t := 1 to KeyMapAliasMax do begin
						if (UpCase(KeyMapAlias[t].CmdName) = cmd) then begin
							Use_KeyMapAlias := false;
							break;
						end;
					end;
					for t := 1 to KeyMapAliasMax do begin
						if (UpCase(KeyMapAlias[t].CmdAlias) = cmd) then begin
							Done := true;
							Use_KeyMapAlias := true;
							cmd := UpCase(KeyMapAlias[t].CmdName);
							break;
						end;
					end;
{$ENDIF PATCH_GH}
					for t := 1 to NumMappedKeys do begin
						if UpCase(KeyMap[t].CmdName) = cmd then
						begin
{$IFDEF PATCH_GH}
							Done := true;
{$ENDIF PATCH_GH}
							C := ExtractWord(S);
{$IFDEF PATCH_GH}
							KCode_from_tmp := KeyMapDecode(C);
							if (KBD_ERROR <> KCode_from_tmp) then begin
								KeyMap[t].KCode := KCode_from_tmp;
							end;
{$ELSE PATCH_GH}
							if Length(C) = 1 then begin
								KeyMap[t].KCode := C[1];
							end;
{$ENDIF PATCH_GH}
						end;
					end;
{$IFDEF PATCH_GH}
					if ( 'KCODEALIAS' = cmd ) and ( KCodeAlias_ptr < KCodeAliasMax) then begin
						Done := true;
						C := ExtractWord(S);
						KCode_from_tmp := KeyMapDecode(C);
						if (KBD_ERROR <> KCode_from_tmp) then begin
							C := ExtractWord(S);
							KCode_to_tmp := KeyMapDecode(C);
							if (KBD_ERROR <> KCode_to_tmp) then begin
								KCodeAlias[KCodeAlias_ptr].KCode_from := KCode_from_tmp;
								KCodeAlias[KCodeAlias_ptr].KCode_to := KCode_to_tmp;
								Inc( KCodeAlias_ptr );
								KCodeAlias[KCodeAlias_ptr].KCode_from := KBD_ERROR;
							end;
						end;
					end;
{$ENDIF PATCH_GH}

					{ Check to see if CMD is the animation speed throttle. }
					if cmd = 'ANIMSPEED' then begin
						T := ExtractValue( S );
						if T < 0 then T := 0;
						FrameDelay := T;
					end else if cmd = 'MECHACONTROL' then begin
						C := UpCase( ExtractWord( S ) );
						case C[1] of
							'M': ControlMethod := MenuBasedInput;
							'R': ControlMethod := RLBasedInput;
						end;
					end else if cmd = 'CHARACONTROL' then begin
						C := UpCase( ExtractWord( S ) );
						case C[1] of
							'M': CharacterMethod := MenuBasedInput;
							'R': CharacterMethod := RLBasedInput;
						end;
					end else if cmd = 'WORLDCONTROL' then begin
						C := UpCase( ExtractWord( S ) );
						case C[1] of
							'M': WorldMapMethod := MenuBasedInput;
							'R': WorldMapMethod := RLBasedInput;
						end;

					end else if cmd = 'MISSILEBV' then begin
						C := UpCase( ExtractWord( S ) );
						for t := 1 to 4 do begin
							if UpCase(BVTypeName[t]) = C then begin
								DefMissileBV := T;
							end;
						end;

					end else if cmd = 'BALLISTICBV' then begin
						C := UpCase( ExtractWord( S ) );
						for t := 1 to 4 do begin
							if UpCase(BVTypeName[t]) = C then begin
								DefBallisticBV := T;
							end;
						end;

					end else if cmd = 'BEAMGUNBV' then begin
						C := UpCase( ExtractWord( S ) );
						for t := 1 to 4 do begin
							if UpCase(BVTypeName[t]) = C then begin
								DefBeamGunBV := T;
							end;
						end;
					end else if cmd = 'DIRECTSKILLOK' then begin
						Direct_Skill_Learning := True;

					end else if cmd = 'NOAUTOSAVE' then begin
						DoAutoSave := False;
					end else if cmd = 'ALWAYSSAVECHARACTER' then begin
						ALWAYS_SAVE_CHARACTER := True;
					end else if cmd = 'NOCOMBATTAUNTS' then begin
						No_Combat_Taunts := True;

					end else if cmd = 'NOALPHA' then begin
						Use_Alpha_Blending := False;
					end else if cmd = 'NO_TRANSPARENT_INTERFACE' then begin
						Transparent_Interface := False;
					end else if cmd = 'ALPHALEVEL' then begin
						T := ExtractValue( S );
						if T > 255 then T := 255
						else if T < 0 then T := 0;
						Alpha_Level := T;

					end else if cmd = 'NUMPLOTS' then begin
						T := ExtractValue( S );
						if T > 255 then T := 255
						else if T < 0 then T := 0;
						Max_Plots_Per_Adventure := T;

					end else if cmd = 'LOADPLOTSATSTART' then begin
						Load_Plots_At_Start := True;

					end else if cmd = 'MINIMAPON' then begin
						Display_Mini_Map := True;
{$IFDEF PATCH_GH}
					end else if cmd = 'MINIMAP_WITH_ALLGEARS' then begin
						Display_Mini_Map_with_All_Gears := True;
{$ENDIF PATCH_GH}

					end else if cmd = 'SCREENHEIGHT' then begin
						T := ExtractValue( S );
						if T > 255 then T := 255
						else if T < 24 then T := 24;
						ScreenRows := T;

					end else if cmd = 'SCREENWIDTH' then begin
						T := ExtractValue( S );
						if T > 255 then T := 255
						else if T < 80 then T := 80;
						ScreenColumns := T;

					end else if cmd = 'FULLSCREEN' then begin
						DoFullScreen := True;

					end else if cmd = 'NOMOUSE' then begin
						Mouse_Active := False;

					end else if cmd = 'NAMESON' then begin
						Names_Above_Heads := True;

					end else if cmd = 'NOPILLAGE' then begin
						Pillage_On := False;
					end else if cmd = 'USETACTICSMODE' then begin
						UseTacticsMode := True;

					end else if cmd = 'ADVANCEDCOLORS' then begin
						UseAdvancedColoring := True;

					end else if cmd = 'ACCESSIBILITY_ON' then begin
						Accessibility_On := True;

{$IFDEF PATCH_I18N}
					end else if cmd = 'I18N_USEORIGINALNAME' then begin
						if ExtractTF(S) then I18N_UseOriginalName := True else I18N_UseOriginalName := False;
					end else if cmd = 'I18N_USENAMEORG' then begin
						if ExtractTF(S) then I18N_UseNameORG := True else I18N_UseNameORG := False;
					end else if cmd = 'FONTFILEBIG' then begin
						FontSearchName_Big[1].FontFile   := ExtractWord( S );
						FontSearchName_Big[1].FontFace   := ExtractValue( S );
						if FontSearchName_Big[1].FontFace < 0 then begin FontSearchName_Big[1].FontFace := 0; end;
					end else if cmd = 'FONTFILESMALL' then begin
						FontSearchName_Small[1].FontFile := ExtractWord( S );
						FontSearchName_Small[1].FontFace := ExtractValue( S );
						if FontSearchName_Small[1].FontFace < 0 then begin FontSearchName_Small[1].FontFace := 0; end;
					end else if cmd = 'FONTSIZEBIG' then begin
						FontSize_Big := ExtractValue( S );
						if FontSize_Big < 1 then begin FontSize_Big := 0; end;
					end else if cmd = 'FONTSIZESMALL' then begin
						FontSize_Small := ExtractValue( S );
						if FontSize_Small < 1 then begin FontSize_Small := 0; end;
					end else if cmd = 'FONTNAMEOTHER' then begin
  {IF DEFINED(WINDOWS)}
						DeleteWhiteSpace( S );
						MSWINGUI_FontName := S;
  {ENDIF}
					end else if cmd = 'FONTWEIGHTOTHER' then begin
  {IF DEFINED(WINDOWS)}
						MSWINGUI_FontWeight := ExtractValue( S );
						if MSWINGUI_FontWeight < 0 then begin MSWINGUI_FontWeight := 0; end;
  {ENDIF}
					end else if cmd = 'FONTSIZEOTHER' then begin
  {IF DEFINED(WINDOWS)}
						MSWINGUI_FontSize := ExtractValue( S );
						if MSWINGUI_FontSize < 1 then begin MSWINGUI_FontSize := 0; end;
  {ENDIF}
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_JPSSDL}
					end else if cmd = 'PADLEFT' then begin
						Pad_Left := ExtractValue( S );
					end else if cmd = 'PADTOP' then begin
						Pad_Top := ExtractValue( S );
					end else if cmd = 'SKIPANIM' then begin
						if ExtractTF(S) then SkipAnim := True else SkipAnim := False;
					end else if cmd = 'DRAWWALLMODE' then begin
						DrawWallMode := ExtractValue( S );
						if 4 < DrawWallMode then begin DrawWallMode := 4 end
						else if DrawWallMode < 0 then begin DrawWallMode := 0 end;
{$ENDIF PATCH_JPSSDL}
{$IFDEF PATCH_HEART}
					end else if cmd = 'KEYWAIT' then begin
						KeyWait := ExtractValue( S );
						if KeyWait < 0 then begin KeyWait := 0; end;
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_GH}
					end else if cmd = 'SDL_ACCELERATED' then begin
						if ExtractTF(S) then SDL_Accelerated := True else SDL_Accelerated := False;
					end else if cmd = 'SDL_PRESENTVSYNC' then begin
						if ExtractTF(S) then SDL_PresentVsync := True else SDL_PresentVsync := False;
					end else if cmd = 'SDL_NOTIMEEVENT' then begin
						if ExtractTF(S) then SDL_NoTimeEvent := True else SDL_NoTimeEvent := False;
					end else if cmd = 'FRAMESKIP' then begin
						if ExtractTF(S) then FrameSkip := True else FrameSkip := False;
					end else if cmd = 'FRAMEINTERVAL' then begin
						FrameInterval := ExtractValue( S );
						if FrameInterval < 0 then begin FrameInterval := 0; end;
					end else if cmd = 'SLEEPGRANULARITY' then begin
						SleepGranularity := ExtractValue( S );
						if SleepGranularity < 0 then begin SleepGranularity := 0; end;
					end else if cmd = 'KEYSAMPLINGINTERVAL' then begin
						KeysamplingInterval := ExtractValue( S );
						if KeysamplingInterval < 0 then begin KeysamplingInterval := 0; end;
					end else if cmd = 'COLOR' then begin
						C := ExtractWord( S );
						for ColorNum := 1 to ColorTable_Num do begin
							if UpCase(ColorTable[ColorNum].Name) = UpCase(C) then begin
								ColorTable[ColorNum].DataPtr^.r := ExtractValue( S );
								ColorTable[ColorNum].DataPtr^.g := ExtractValue( S );
								ColorTable[ColorNum].DataPtr^.b := ExtractValue( S );
								if ColorTable[ColorNum].DataPtr^.r < 0 then begin ColorTable[ColorNum].DataPtr^.r := 0; end;
								if ColorTable[ColorNum].DataPtr^.g < 0 then begin ColorTable[ColorNum].DataPtr^.g := 0; end;
								if ColorTable[ColorNum].DataPtr^.b < 0 then begin ColorTable[ColorNum].DataPtr^.b := 0; end;
								if 255 < ColorTable[ColorNum].DataPtr^.r then begin ColorTable[ColorNum].DataPtr^.r := 255; end;
								if 255 < ColorTable[ColorNum].DataPtr^.g then begin ColorTable[ColorNum].DataPtr^.g := 255; end;
								if 255 < ColorTable[ColorNum].DataPtr^.b then begin ColorTable[ColorNum].DataPtr^.b := 255; end;
							end;
						end;
					end else if cmd = 'SDL_COLORS' then begin
						C := ExtractWord( S );
						for ColorNum := 1 to SDLColorTable_Num do begin
							if UpCase(SDLColorTable[ColorNum].Name) = UpCase(C) then begin
								StrPCopy( SDLColorTable[ColorNum].DataPtr, RetrieveAString(S) );
							end;
						end;
					end else if cmd = 'SDL_MINI' then begin
						if ExtractTF(S) then SDL_Mini := True else SDL_Mini := False;
					end else if cmd = 'CUI_SCREENSIZE' then begin
						CUI_ScreenSize_Width  := ExtractValue( S );
						CUI_ScreenSize_Height := ExtractValue( S );
						if CUI_ScreenSize_Width < 0 then begin CUI_ScreenSize_Width := 0; end;
						if CUI_ScreenSize_Height < 0 then begin CUI_ScreenSize_Height := 0; end;
					end else if cmd = 'SDL_SCREENPOS' then begin
						ScreenPos_X := ExtractValue( S );
						ScreenPos_Y := ExtractValue( S );
					end else if cmd = 'SDL_SCREENSIZE' then begin
						ScreenSize_Width  := ExtractValue( S );
						ScreenSize_Height := ExtractValue( S );
						if ScreenSize_Width < 0 then begin ScreenSize_Width := 0; end;
						if ScreenSize_Height < 0 then begin ScreenSize_Height := 0; end;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
					end else if cmd = 'SDL_QRLVIEWER_SCREENSIZE' then begin
						QRLViewer_ScreenSize_Width  := ExtractValue( S );
						QRLViewer_ScreenSize_Height := ExtractValue( S );
						if QRLViewer_ScreenSize_Width < 0 then begin QRLViewer_ScreenSize_Width := 320; end;
						if QRLViewer_ScreenSize_Height < 0 then begin QRLViewer_ScreenSize_Height := 240; end;
					end else if cmd = 'SDL_QRLVIEWER_SCREENPOS' then begin
						QRLViewer_ScreenPos_X := ExtractValue( S );
						QRLViewer_ScreenPos_Y := ExtractValue( S );
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_I18N}
					end else if cmd = 'SDL_AAFONT' then begin
						if ExtractTF(S) then SDL_AAFont := True else SDL_AAFont := False;
					end else if cmd = 'SDL_AAFONT_SHADED' then begin
						if ExtractTF(S) then SDL_AAFont_Shaded := True else SDL_AAFont_Shaded := False;
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
					end else if cmd = 'ENABLE_ARENAMODE' then begin
						if ExtractTF(S) then Enable_ArenaMode := True else Enable_ArenaMode := False;
					end else if cmd = 'ENABLE_EDITMAP' then begin
						if ExtractTF(S) then Enable_EditMap := True else Enable_EditMap := False;
					end else if cmd = 'ENABLE_POINTANIMATION' then begin
						if ExtractTF(S) then Enable_PointAnimation := True else Enable_PointAnimation := False;
					end else if cmd = 'ENABLE_MOUSECLICK_OUTSIDETHEMENUAREA' then begin
						if ExtractTF(S) then Enable_MouseClick_OutsideTheMenuArea := True else Enable_MouseClick_OutsideTheMenuArea := False;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_l0ugh}
					end else if cmd = 'KEYBIND_ROGUEMOVE' then begin
						if ExtractTF(S) then KeyBind_RogueMove := True else KeyBind_RogueMove := False;
{$ENDIF PATCH_l0ugh}
{$IFDEF PATCH_GH}
					end else if cmd = 'SELECTMENU_SCROLL_BY_EDGE' then begin
						if ExtractTF(S) then SelectMenu_Scroll_by_Edge := True else SelectMenu_Scroll_by_Edge := False;
					end else if cmd = 'SHOW_MENUSCROLLBAR' then begin
						if ExtractTF(S) then Show_MenuScrollbar := True else Show_MenuScrollbar := False;
					end else if cmd = 'SDL_SHOW_MENUSCROLLBAR' then begin
						if ExtractTF(S) then SDL_Show_MenuScrollbar := True else SDL_Show_MenuScrollbar := False;
					end else if cmd = 'SDL_SCROLLBAR_SIZE' then begin
						SDL_Scrollbar_Size := ExtractValue( S );
						if SDL_Scrollbar_Size < 3 then begin SDL_Scrollbar_Size := 3; end;
					end else if cmd = 'SDL_CHANGE_DIALOGHEIGHT' then begin
						SDL_Change_DialogHeight := ExtractValue( S );
						if SDL_Change_DialogHeight < 0 then begin SDL_Change_DialogHeight := 0; end;
					end else if cmd = 'SHOW_MENUPAGE' then begin
						if ExtractTF(S) then Show_MenuPage := True else Show_MenuPage := False;
					end else if cmd = 'CHEAT_DISPLAYGEARINFO' then begin
						if ExtractTF(S) then Cheat_DisplayGearInfo := True else Cheat_DisplayGearInfo := False;
					end else if cmd = 'CHEAT_DISPLAY_MEMONUMBER' then begin
						if ExtractTF(S) then Cheat_Display_MemoNumber := True else Cheat_Display_MemoNumber := False;
					end else if cmd = 'CHEAT_ASCII_DISPLAY_CHARACTERDISPLAY' then begin
						if ExtractTF(S) then Cheat_ASCII_Display_CharacterDisplay := True else Cheat_ASCII_Display_CharacterDisplay := False;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_CHEAT}
					end else if cmd = 'CHEAT_DISPLAY' then begin
						if ExtractTF(S) then Cheat_Display := True else Cheat_Display := False;
						Cheat_Display_SW := Cheat_Display;
					end else if cmd = 'CHEAT_DISPLAY_DESIG' then begin
						if ExtractTF(S) then Cheat_Display_DESIG := True else Cheat_Display_DESIG := False;
					end else if cmd = 'CHEAT_DISPLAY_OVERLOAD' then begin
						if ExtractTF(S) then Cheat_Display_OverLoad := True else Cheat_Display_OverLoad := False;
					end else if cmd = 'CHEAT_DISPLAY_DAMAGEPERCENT' then begin
						if ExtractTF(S) then Cheat_Display_DamagePercent := True else Cheat_Display_DamagePercent := False;
					end else if cmd = 'CHEAT_DISPLAY_SPEEDOMETER' then begin
						if ExtractTF(S) then Cheat_Display_SpeedoMeter := True else Cheat_Display_SpeedoMeter := False;
					end else if cmd = 'CHEAT_DISPLAY_PV' then begin
						if ExtractTF(S) then Cheat_Display_PV := True else Cheat_Display_PV := False;
					end else if cmd = 'CHEAT_SHOW_ALWAYS_EXTENDEDDESCRIPTION' then begin
						if ExtractTF(S) then Cheat_Show_Always_ExtendedDescription := True else Cheat_Show_Always_ExtendedDescription := False;
					end else if cmd = 'CHEAT_SHOW_SF' then begin
						if ExtractTF(S) then Cheat_Show_SF := True else Cheat_Show_SF := False;
					end else if cmd = 'CHEAT_SHOW_SIZE' then begin
						if ExtractTF(S) then Cheat_Show_Size := True else Cheat_Show_Size := False;
					end else if cmd = 'CHEAT_SHOW_PV' then begin
						if ExtractTF(S) then Cheat_Show_PV := True else Cheat_Show_PV := False;
					end else if cmd = 'CHEAT_PRINT_TIMESTRING' then begin
						if ExtractTF(S) then Cheat_Print_TimeString := True else Cheat_Print_TimeString := False;
					end else if cmd = 'CHEAT_PRINT_ATTEMPTDEFENSES' then begin
						if ExtractTF(S) then Cheat_Print_AttemptDefenses := True else Cheat_Print_AttemptDefenses := False;
					end else if cmd = 'CHEAT_PRINT_AMMOEXPLOSION' then begin
						if ExtractTF(S) then Cheat_Print_AmmoExplosion := True else Cheat_Print_AmmoExplosion := False;
					end else if cmd = 'CHEAT_PRINT_DOPILLAGE' then begin
						if ExtractTF(S) then Cheat_Print_DoPillage := True else Cheat_Print_DoPillage := False;
					end else if cmd = 'CHEAT_PRINT_DRAIN_MAXHP' then begin
						if ExtractTF(S) then Cheat_Print_Drain_MaxHP := True else Cheat_Print_Drain_MaxHP := False;
					end else if cmd = 'CHEAT_AUTOSAVE_TRACE' then begin
						if ExtractTF(S) then Cheat_Autosave_Trace := True else Cheat_Autosave_Trace := False;
					end else if cmd = 'CHEAT_AUTOSAVE_WITH_TIMESTAMP' then begin
						if ExtractTF(S) then Cheat_Autosave_with_Timestamp := True else Cheat_Autosave_with_Timestamp := False;
					end else if cmd = 'CHEAT_MAINMENU_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_MainMenu_AddMenuKey := True else Cheat_MainMenu_AddMenuKey := False;
					end else if cmd = 'CHEAT_RESTORE_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_Restore_AddMenuKey := True else Cheat_Restore_AddMenuKey := False;
					end else if cmd = 'CHEAT_CHAT' then begin
						if ExtractTF(S) then Cheat_Chat := True else Cheat_Chat := False;
					end else if cmd = 'CHEAT_CHAT_REVERSESORT' then begin
						if ExtractTF(S) then Cheat_Chat_ReverseSort := True else Cheat_Chat_ReverseSort := False;
					end else if cmd = 'CHEAT_CALLSHOT' then begin
						if ExtractTF(S) then Cheat_CallShot := True else Cheat_CallShot := False;
					end else if cmd = 'CHEAT_CALLSHOT_CANCEL' then begin
						if ExtractTF(S) then Cheat_CallShot_Cancel := True else Cheat_CallShot_Cancel := False;
					end else if cmd = 'CHEAT_CALLSHOT_OMITLOOKINFO' then begin
						if ExtractTF(S) then Cheat_CallShot_OmitLookInfo := True else Cheat_CallShot_OmitLookInfo := False;
					end else if cmd = 'CHEAT_RANGE_COLORED' then begin
						if ExtractTF(S) then Cheat_Range_Colored := True else Cheat_Range_Colored := False;
					end else if cmd = 'CHEAT_RANGE_WITH_ALTITUDE' then begin
						if ExtractTF(S) then Cheat_Range_with_Altitude := True else Cheat_Range_with_Altitude := False;
					end else if cmd = 'CHEAT_MENUORDER_EDIT' then begin
						if ExtractTF(S) then Cheat_MenuOrder_Edit := True else Cheat_MenuOrder_Edit := False;
					end else if cmd = 'CHEAT_MECHAPARTBROWSER_DELETE' then begin
						if ExtractTF(S) then Cheat_MechaPartBrowser_Delete := True else Cheat_MechaPartBrowser_Delete := False;
					end else if cmd = 'CHEAT_NPC_EDIT' then begin
						if ExtractTF(S) then Cheat_NPC_Edit := True else Cheat_NPC_Edit := False;
					end else if cmd = 'CHEAT_UNLIMITED_SPRITE' then begin
						if ExtractTF(S) then Cheat_Unlimited_Sprite := True else Cheat_Unlimited_Sprite := False;
					end else if cmd = 'CHEAT_UNLIMITED_PORTRAIT' then begin
						if ExtractTF(S) then Cheat_Unlimited_Portrait := True else Cheat_Unlimited_Portrait := False;
					end else if cmd = 'CHEAT_LOOKINFO' then begin
						if ExtractTF(S) then Cheat_LookInfo := True else Cheat_LookInfo := False;
					end else if cmd = 'CHEAT_ENABLE_LIMIT_SELLINGPRICE' then begin
						if ExtractTF(S) then Cheat_Enable_Limit_SellingPrice := True else Cheat_Enable_Limit_SellingPrice := False;
					end else if cmd = 'CHEAT_BUYSTUFF_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_BuyStuff_ShowSubItem := True else Cheat_BuyStuff_ShowSubItem := False;
					end else if cmd = 'CHEAT_BUYSTUFF_MECHA_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_BuyStuff_Mecha_ShowSubItem := True else Cheat_BuyStuff_Mecha_ShowSubItem := False;
					end else if cmd = 'CHEAT_BUYSTUFF_SORT' then begin
						if ExtractTF(S) then Cheat_BuyStuff_Sort := True else Cheat_BuyStuff_Sort := False;
					end else if cmd = 'CHEAT_SELLSTUFF_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_SellStuff_ShowSubItem := True else Cheat_SellStuff_ShowSubItem := False;
					end else if cmd = 'CHEAT_SELLSTUFF_SORT' then begin
						if ExtractTF(S) then Cheat_SellStuff_Sort := True else Cheat_SellStuff_Sort := False;
					end else if cmd = 'CHEAT_SELLSTUFF_KEEPPOSITION' then begin
						if ExtractTF(S) then Cheat_SellStuff_KeepPosition := True else Cheat_SellStuff_KeepPosition := False;
					end else if cmd = 'CHEAT_EQPMENU_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_EqpMenu_AddMenuKey := True else Cheat_EqpMenu_AddMenuKey := False;
					end else if cmd = 'CHEAT_EQPMENU_KEEPPOSITION' then begin
						if ExtractTF(S) then Cheat_EqpMenu_KeepPosition := True else Cheat_EqpMenu_KeepPosition := False;
					end else if cmd = 'CHEAT_EQPMENU_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_EqpMenu_ShowSubItem := True else Cheat_EqpMenu_ShowSubItem := False;
					end else if cmd = 'CHEAT_EQPMENU_SHOWMASSMETER' then begin
						if ExtractTF(S) then Cheat_EqpMenu_ShowMassMeter := True else Cheat_EqpMenu_ShowMassMeter := False;
					end else if cmd = 'CHEAT_EQPMENU_SHOWFULLGEARNAME' then begin
						if ExtractTF(S) then Cheat_EqpMenu_ShowFullGearName := True else Cheat_EqpMenu_ShowFullGearName := False;
					end else if cmd = 'CHEAT_INVMENU_KEEPPOSITION' then begin
						if ExtractTF(S) then Cheat_InvMenu_KeepPosition := True else Cheat_InvMenu_KeepPosition := False;
					end else if cmd = 'CHEAT_INVMENU_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_InvMenu_ShowSubItem := True else Cheat_InvMenu_ShowSubItem := False;
					end else if cmd = 'CHEAT_INVMENU_NOSORT' then begin
						if ExtractTF(S) then Cheat_InvMenu_NoSort := True else Cheat_InvMenu_NoSort := False;
					end else if cmd = 'CHEAT_SHOW_COMPONENTMASS' then begin
						if ExtractTF(S) then Cheat_Show_ComponentMass := True else Cheat_Show_ComponentMass := False;
					end else if cmd = 'CHEAT_MECHADESCRIPTION_SHOWMASSMETER' then begin
						if ExtractTF(S) then Cheat_MechaDescription_ShowMassMeter := True else Cheat_MechaDescription_ShowMassMeter := False;
					end else if cmd = 'CHEAT_MECHAPARTEDITOR_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_MechaPartEditor_AddMenuKey := True else Cheat_MechaPartEditor_AddMenuKey := False;
					end else if cmd = 'CHEAT_MECHAPARTEDITOR_KEEPPOSITION' then begin
						if ExtractTF(S) then Cheat_MechaPartEditor_KeepPosition := True else Cheat_MechaPartEditor_KeepPosition := False;
					end else if cmd = 'CHEAT_PCVIEW_TRAINING_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_PCVIEW_Training_AddMenuKey := True else Cheat_PCVIEW_Training_AddMenuKey := False;
					end else if cmd = 'CHEAT_PCVIEW_TRAINING_KEEPPOSITION' then begin
						if ExtractTF(S) then Cheat_PCVIEW_Training_KeepPosition := True else Cheat_PCVIEW_Training_KeepPosition := False;
					end else if cmd = 'CHEAT_FIELDHQ_MECHA_NOSORT' then begin
						if ExtractTF(S) then Cheat_FieldHQ_Mecha_NoSort := True else Cheat_FieldHQ_Mecha_NoSort := False;
					end else if cmd = 'CHEAT_FIELDHQ_MECHA_KEEPPOSITION' then begin
						if ExtractTF(S) then Cheat_FieldHQ_Mecha_KeepPosition := True else Cheat_FieldHQ_Mecha_KeepPosition := False;
					end else if cmd = 'CHEAT_FIELDHQ_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_FieldHQ_AddMenuKey := True else Cheat_FieldHQ_AddMenuKey := False;
					end else if cmd = 'CHEAT_INSTALLMISC_SHOWPARENTITEM' then begin
						if ExtractTF(S) then Cheat_InstallMisc_ShowParentItem := True else Cheat_InstallMisc_ShowParentItem := False;
					end else if cmd = 'CHEAT_EQUIPITEM_SHOWPARENTITEM' then begin
						if ExtractTF(S) then Cheat_EquipItem_ShowParentItem := True else Cheat_EquipItem_ShowParentItem := False;
					end else if cmd = 'CHEAT_INSTALLMISC_SHOWINVSTR' then begin
						if ExtractTF(S) then Cheat_InstallMisc_ShowInvStr := True else Cheat_InstallMisc_ShowInvStr := False;
					end else if cmd = 'CHEAT_EQUIPITEM_SHOWINVSTR' then begin
						if ExtractTF(S) then Cheat_EquipItem_ShowInvStr := True else Cheat_EquipItem_ShowInvStr := False;
					end else if cmd = 'CHEAT_INSTALLAMMO_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_InstallAmmo_ShowSubItem := True else Cheat_InstallAmmo_ShowSubItem := False;
					end else if cmd = 'CHEAT_EQUIPITEM_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_EquipItem_ShowSubItem := True else Cheat_EquipItem_ShowSubItem := False;
					end else if cmd = 'CHEAT_INSTALL_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_Install_ShowSubItem := True else Cheat_Install_ShowSubItem := False;
					end else if cmd = 'CHEAT_INSTALLCYBERWARE_SHOWSUBITEM' then begin
						if ExtractTF(S) then Cheat_InstallCyberware_ShowSubItem := True else Cheat_InstallCyberware_ShowSubItem := False;
					end else if cmd = 'CHEAT_EXTENDEDDESCRIPTION_SHOWHIGHOUTPUT' then begin
						if ExtractTF(S) then Cheat_ExtendedDescription_ShowHighOutput := True else Cheat_ExtendedDescription_ShowHighOutput := False;
					end else if cmd = 'CHEAT_GEARNAME_ADDSCALENUMBER' then begin
						if ExtractTF(S) then Cheat_GearName_AddScaleNumber := True else Cheat_GearName_AddScaleNumber := False;
					end else if cmd = 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGMODULE' then begin
						if ExtractTF(S) then Cheat_GearName_AddClassNumber_GGModule := True else Cheat_GearName_AddClassNumber_GGModule := False;
					end else if cmd = 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGMECHA' then begin
						if ExtractTF(S) then Cheat_GearName_AddClassNumber_GGMecha := True else Cheat_GearName_AddClassNumber_GGMecha := False;
					end else if cmd = 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGHOLDER' then begin
						if ExtractTF(S) then Cheat_GearName_AddClassNumber_GGHolder := True else Cheat_GearName_AddClassNumber_GGHolder := False;
					end else if cmd = 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGSUPPORT' then begin
						if ExtractTF(S) then Cheat_GearName_AddClassNumber_GGSupport := True else Cheat_GearName_AddClassNumber_GGSupport := False;
					end else if cmd = 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGCONSUMABLE' then begin
						if ExtractTF(S) then Cheat_GearName_AddClassNumber_GGConsumable := True else Cheat_GearName_AddClassNumber_GGConsumable := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_LIMITLESS' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_Limitless := True else Cheat_MechaCustomize_Limitless := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREESUPPORT' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeSupport := True else Cheat_MechaCustomize_FreeSupport := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREECOCKPIT' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeCockpit := True else Cheat_MechaCustomize_FreeCockpit := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREEMASTERGEAR' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeMasterGear := True else Cheat_MechaCustomize_FreeMasterGear := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREEPARENT' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeParent := True else Cheat_MechaCustomize_FreeParent := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREESCALE' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeScale := True else Cheat_MechaCustomize_FreeScale := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREEMODIFIER' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeModifier := True else Cheat_MechaCustomize_FreeModifier := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREEBODYMODULE' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeBodyModule := True else Cheat_MechaCustomize_FreeBodyModule := False;
					end else if cmd = 'CHEAT_MECHACUSTOMIZE_FREEINTEGRAL' then begin
						if ExtractTF(S) then Cheat_MechaCustomize_FreeIntegral := True else Cheat_MechaCustomize_FreeIntegral := False;
					end else if cmd = 'CHEAT_TRADE_NOTSAFEAREA' then begin
						if ExtractTF(S) then Cheat_Trade_NotSafeArea := True else Cheat_Trade_NotSafeArea := False;
					end else if cmd = 'CHEAT_TRADE_LANCEMATEMENUNAME' then begin
						if ExtractTF(S) then Cheat_Trade_LanceMateMenuName := True else Cheat_Trade_LanceMateMenuName := False;
					end else if cmd = 'CHEAT_ROGUELIKE_DEATH' then begin
						if ExtractTF(S) then Cheat_Roguelike_Death := True else Cheat_Roguelike_Death := False;
					end else if cmd = 'CHEAT_ARENAMODE_MAINMENU_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_ArenaMode_MainMenu_AddMenuKey := True else Cheat_ArenaMode_MainMenu_AddMenuKey := False;
					end else if cmd = 'CHEAT_ARENAMODE_PILOTSMENU_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_ArenaMode_PilotsMenu_AddMenuKey := True else Cheat_ArenaMode_PilotsMenu_AddMenuKey := False;
					end else if cmd = 'CHEAT_ARENAMODE_MECHAMENU_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_ArenaMode_MechaMenu_AddMenuKey := True else Cheat_ArenaMode_MechaMenu_AddMenuKey := False;
					end else if cmd = 'CHEAT_ARENAMODE_PILOTSHQ_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_ArenaMode_PilotsHQ_AddMenuKey := True else Cheat_ArenaMode_PilotsHQ_AddMenuKey := False;
					end else if cmd = 'CHEAT_ARENAMODE_MECHAHQ_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_ArenaMode_MechaHQ_AddMenuKey := True else Cheat_ArenaMode_MechaHQ_AddMenuKey := False;
					end else if cmd = 'CHEAT_ARENAMODE_ALLRECOVERYINHQ' then begin
						if ExtractTF(S) then Cheat_ArenaMode_AllRecoveryInHQ := True else Cheat_ArenaMode_AllRecoveryInHQ := False;
					end else if cmd = 'CHEAT_ARENAMODE_INVENTORYINHQ' then begin
						if ExtractTF(S) then Cheat_ArenaMode_InventoryInHQ := True else Cheat_ArenaMode_InventoryInHQ := False;
					end else if cmd = 'CHEAT_ARENAMODE_FIELDHQINHQ' then begin
						if ExtractTF(S) then Cheat_ArenaMode_FieldHQInHQ := True else Cheat_ArenaMode_FieldHQInHQ := False;
					end else if cmd = 'CHEAT_ARENAMODE_MAPSELECT' then begin
						if ExtractTF(S) then Cheat_ArenaMode_MapSelect := True else Cheat_ArenaMode_MapSelect := False;
					end else if cmd = 'CHEAT_THISITEMWASSELECTED_ADDMENUKEY' then begin
						if ExtractTF(S) then Cheat_ThisItemWasSelected_AddMenuKey := True else Cheat_ThisItemWasSelected_AddMenuKey := False;
					end else if cmd = 'CHEAT_ENABLECOCKPITBARRIER' then begin
						if ExtractTF(S) then Cheat_EnableCockpitBarrier := True else Cheat_EnableCockpitBarrier := False;
					end else if cmd = 'CHEAT_ENABLECOCKPITBARRIER_HAND' then begin
						if ExtractTF(S) then Cheat_EnableCockpitBarrier_Hand := True else Cheat_EnableCockpitBarrier_Hand := False;
					end else if cmd = 'CHEAT_DONOTRUNWHENMOUSECLICKED' then begin
						if ExtractTF(S) then Cheat_DoNotRunWhenMouseClicked := True else Cheat_DoNotRunWhenMouseClicked := False;
					end else if cmd = 'CHEAT_DONOTTARGETMATERIAL' then begin
						if ExtractTF(S) then Cheat_DoNotTargetMaterial := True else Cheat_DoNotTargetMaterial := False;
					end else if cmd = 'CHEAT_ENABLE_SUBINVMENU' then begin
						if ExtractTF(S) then Cheat_Enable_SubInvMenu := True else Cheat_Enable_SubInvMenu := False;
					end else if cmd = 'CHEAT_NPCONMECHAWILLREPAIR' then begin
						if ExtractTF(S) then Cheat_NPConMechaWillRepair := True else Cheat_NPConMechaWillRepair := False;
					end else if cmd = 'CHEAT_AVOID_ZOMBIE' then begin
						if ExtractTF(S) then Cheat_Avoid_Zombie := True else Cheat_Avoid_Zombie := False;
					end else if cmd = 'CHEAT_NPC_AVOIDATTACKTONEUTRALITY' then begin
						if ExtractTF(S) then Cheat_NPC_AvoidAttackToNeutrality := True else Cheat_NPC_AvoidAttackToNeutrality := False;
					end else if cmd = 'CHEAT_NPC_USEGRENADE' then begin
						if ExtractTF(S) then Cheat_NPC_UseGrenade := True else Cheat_NPC_UseGrenade := False;
					end else if cmd = 'CHEAT_DONOTROUNDUP_ARP' then begin
						if ExtractTF(S) then Cheat_DoNotRoundUp_ARP := True else Cheat_DoNotRoundUp_ARP := False;
					end else if cmd = 'CHEAT_RELOADALLMECHA' then begin
						if ExtractTF(S) then Cheat_ReloadAllMecha := True else Cheat_ReloadAllMecha := False;
					end else if cmd = 'CHEAT_SHOW_WEAPONRECHARGE' then begin
						if ExtractTF(S) then Cheat_Show_WeaponRecharge := True else Cheat_Show_WeaponRecharge := False;
					end else if cmd = 'CHEAT_FIX_SOLVELINE' then begin
						if ExtractTF(S) then Cheat_Fix_SolveLine := True else Cheat_Fix_SolveLine := False;
					end else if cmd = 'CHEAT_SHOW_RANGECOVER' then begin
						if ExtractTF(S) then Cheat_Show_RangeCover := True else Cheat_Show_RangeCover := False;
					end else if cmd = 'CHEAT_SELECTSPRITE' then begin
						if ExtractTF(S) then Cheat_SelectSprite := True else Cheat_SelectSprite := False;
					end else if cmd = 'CHEAT_SHOW_NEEDHAND' then begin
						if ExtractTF(S) then Cheat_Show_NeedHand := True else Cheat_Show_NeedHand := False;
{$ENDIF PATCH_CHEAT}
{$IFDEF PATCH_HEART}
					end else if cmd = 'CHEAT_ALWAYS_GETPLAYERINPUT' then begin
						if ExtractTF(S) then Cheat_Always_GetPlayerInput := True else Cheat_Always_GetPlayerInput := False;
					end else if cmd = 'DEBUG_ENABLELUADEBUGGER' then begin
						if ExtractTF(S) then DEBUG_EnableLuaDebugger := True else DEBUG_EnableLuaDebugger := False;
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_BACKPORT}
					end else if cmd = 'BACKPORT_CALIBER' then begin
						if ExtractTF(S) then Backport_Caliber := True else Backport_Caliber := False;
					end else if cmd = 'BACKPORT_CALIBER_GH1COMPATIBLE' then begin
						if ExtractTF(S) then Backport_Caliber_GH1Compatible := True else Backport_Caliber_GH1Compatible := False;
{$ENDIF PATCH_BACKPORT}
{$IFDEF PATCH_GH}
  {IFDEF DEBUG}
					end else if cmd = 'DEBUG_MEMORYLEAK' then begin
						if ExtractTF(S) then DEBUG_MemoryLeak := True else DEBUG_MemoryLeak := False;
					end else if cmd = 'DEBUG_TRACEMACRO' then begin
						if ExtractTF(S) then DEBUG_TraceMacro := True else DEBUG_TraceMacro := False;
					end else if cmd = 'DEBUG_GRABBED_GEAR' then begin
						if ExtractTF(S) then DEBUG_Grabbed_Gear := True else DEBUG_Grabbed_Gear := False;
					end else if cmd = 'DEBUG_SCRIPT_DYNAMICENCOUNTER' then begin
						if ExtractTF(S) then DEBUG_SCRIPT_DynamicEncounter := True else DEBUG_SCRIPT_DynamicEncounter := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_NEWGEAR' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_NewGear := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_NewGear := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_DISPOSEGEAR' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_DisposeGear := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_DisposeGear := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_DELEGEGG' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_DelegeGG := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_DelegeGG := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_ENDSTORY' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_EndStory := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_EndStory := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_CLEANUPSTORYPLOTS' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_CleanupStoryPlots := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_CleanupStoryPlots := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_PURGE_GG_ABSOLUTELYNOTHING' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_AbsolutelyNothing := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_AbsolutelyNothing := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_MARK_GG_DISPOSEGEAR' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_Mark_GG_DisposeGear := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_Mark_GG_DisposeGear := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_PURGE_GG_DISPOSEGEAR' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_DisposeGear := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_DisposeGear := False;
					end else if cmd = 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_CHANGE_SCENE' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_Grabbed_Gear_when_Change_Scene := True else DEBUG_DONOT_NIL_Grabbed_Gear_when_Change_Scene := False;
					end else if cmd = 'DEBUG_DONOT_NIL_SCRIPT_DYNAMICENCOUNTER' then begin
						if ExtractTF(S) then DEBUG_DONOT_NIL_SCRIPT_DynamicEncounter := True else DEBUG_DONOT_NIL_SCRIPT_DynamicEncounter := False;
					end else if cmd = 'DEBUG_FORCE_EXEC_MACROUPDATE_WHEN_RESTORE' then begin
						if ExtractTF(S) then DEBUG_FORCE_EXEC_MacroUPDATE_when_Restore := True else DEBUG_FORCE_EXEC_MacroUPDATE_when_Restore := False;
					end else if cmd = 'DEBUG_FORCE_EXEC_MACROSTART_WHEN_RESTORE' then begin
						if ExtractTF(S) then DEBUG_FORCE_EXEC_MacroSTART_when_Restore := True else DEBUG_FORCE_EXEC_MacroSTART_when_Restore := False;
					end else if cmd = 'DEBUG_STOP_MACRORESTORESTART_WHEN_RESTORE' then begin
						if ExtractTF(S) then DEBUG_STOP_MacroRESTORESTART_when_Restore := True else DEBUG_STOP_MacroRESTORESTART_when_Restore := False;
					end else if cmd = 'DEBUG_FORCE_RESTOCKRANDOMMONSTERS_WHEN_RESTORE' then begin
						if ExtractTF(S) then DEBUG_FORCE_RestockRandomMonsters_when_Restore := True else DEBUG_FORCE_RestockRandomMonsters_when_Restore := False;
					end else if cmd = 'DEBUG_MAXCID' then begin
						if ExtractTF(S) then DEBUG_MaxCID := True else DEBUG_MaxCID := False;
					end else if cmd = 'DEBUG_MAXNID' then begin
						if ExtractTF(S) then DEBUG_MaxNID := True else DEBUG_MaxNID := False;
					end else if cmd = 'DEBUG_CANSEEALL' then begin
						if ExtractTF(S) then DEBUG_CanSeeAll := True else DEBUG_CanSeeAll := False;
    {$IFDEF PATCH_HEART}
					end else if cmd = 'DEBUG_TRACEQRL' then begin
						if ExtractTF(S) then DEBUG_TraceQRL := True else DEBUG_TraceQRL := False;
    {$ENDIF PATCH_HEART}
  {ENDIF DEBUG}
{$ENDIF PATCH_GH}
					end else if cmd[1] = '#' then begin
						S := '';
{$IFDEF PATCH_GH}
					end else if cmd = '%' then begin
					end else if (False = Done) then begin
						ErrorMessage_fork('Unknown option : ' + cmd);
{$ENDIF PATCH_GH}
					end;
				end;
			end;

			{ Once the EOF has been reached, close the file. }
			Close(F);
		end;

{$IFDEF PATCH_GH}
  {$IFDEF SDL2}
		if SDL_Accelerated then begin
			SDL_RendererMode := SDL_RENDERER_ACCELERATED or SDL_RENDERER_TARGETTEXTURE;
		end else begin
			SDL_RendererMode := SDL_RENDERER_SOFTWARE or SDL_RENDERER_TARGETTEXTURE;
		end;
		if SDL_PresentVsync then begin
			SDL_RendererMode := SDL_RendererMode or SDL_RENDERER_PRESENTVSYNC;
		end;
  {$ELSE SDL2}
  {$ENDIF SDL2}
{$ENDIF PATCH_GH}

	end;

	Procedure SaveConfig;
		{ Open the configuration file and record the variables }
		{ as needed. }
	var
		F: Text;
		T: Integer;
		Procedure AddBoolean( const OpTag: String; IsOn: Boolean );
			{ Add one of the boolean options to the file. }
		begin
			if IsOn then begin
				writeln( F , OpTag );
			end else begin
				writeln( F , '#' + OpTag );
			end;
		end;
{$IFDEF PATCH_GH}
		Procedure AddTrueFalse( const OpTag: String; IsOn: Boolean );
			{ Add one of the boolean options to the file. }
		begin
			if IsOn then begin
				writeln( F , OpTag + ' TRUE' );
			end else begin
				writeln( F , OpTag + ' FALSE' );
			end;
		end;
	var
		i: Integer;
		KCmdName_tmp: String;
		KCode_tmp: String;
		ColorNum: Integer;
{$ENDIF PATCH_GH}
	begin
		{ If we've found a configuration file, }
		{ open it up and start reading. }
		Assign( F , Config_File );
{$IFDEF PATCH_GH}
		SetTextLineEnding( F , #13#10 );
{$ENDIF PATCH_GH}
		Rewrite( F );

		writeln( F , '#' );
		writeln( F , '# ATTENTION:' );
		writeln( F , '#   Only edit the config file if GearHead is not running.' );
		writeln( F , '#   Configuration overwritten at game exit.' );
		writeln( F , '#' );

		for t := 1 to NumMappedKeys do begin
{$IFDEF PATCH_GH}
			KCmdName_tmp := KeyMap[t].CmdName;
			if Use_KeyMapAlias then begin
				for i := 1 to KeyMapAliasMax do begin
					if (UpCase(KeyMapAlias[i].CmdName) = UpCase(KCmdName_tmp)) then begin
						KCmdName_tmp := KeyMapAlias[i].CmdAlias;
						break;
					end;
				end;
			end;
			KCode_tmp := KeyMapEncode( '#' , KeyMap[t].KCode );
			WriteLn( F, KCmdName_tmp + ' ' + KCode_tmp );
{$ELSE PATCH_GH}
			WriteLn( F, KeyMap[t].CmdName + ' ' + KeyMap[t].KCode );
{$ENDIF PATCH_GH}
		end;
{$IFDEF PATCH_GH}
		i := 1;
		while ( KBD_ERROR <> KCodeAlias[i].KCode_from ) do begin
			WriteLn( F, 'KCodeAlias ' + KeyMapEncode( '#' , KCodeAlias[i].KCode_from ) + ' ' + KeyMapEncode( '#' , KCodeAlias[i].KCode_to ) );
			Inc( i );
		end;
{$ENDIF PATCH_GH}

		writeln( F, 'ANIMSPEED ' + BStr( FrameDelay ) );

		writeln( F, 'MECHACONTROL ' + ControlTypeName[ ControlMethod ] );
		writeln( F, 'CHARACONTROL ' + ControlTypeName[ CharacterMethod ] );
		writeln( F, 'WORLDCONTROL ' + ControlTypeName[ WorldMapMethod ] );

		writeln( F, 'MISSILEBV ' + BVTypeName[ DefMissileBV ] );
		writeln( F, 'BALLISTICBV ' + BVTypeName[ DefBallisticBV ] );
		writeln( F, 'BEAMGUNBV ' + BVTypeName[ DefBeamGunBV ] );

		AddBoolean( 'DIRECTSKILLOK' , Direct_Skill_Learning );
		AddBoolean( 'NOAUTOSAVE' , not DoAutoSave );
		AddBoolean( 'ALWAYSSAVECHARACTER' , Always_Save_Character );
		AddBoolean( 'NOCOMBATTAUNTS' , No_Combat_Taunts );
		AddBoolean( 'NAMESON' , Names_Above_Heads );

		AddBoolean( 'NOALPHA' , not Use_Alpha_Blending );
		AddBoolean( 'NO_TRANSPARENT_INTERFACE' , not Transparent_Interface );
		writeln( F, 'ALPHALEVEL ' + BStr( Alpha_Level ) );

		writeln( F, 'NUMPLOTS ' + BStr( Max_Plots_Per_Adventure ) );
		AddBoolean( 'LOADPLOTSATSTART' , Load_Plots_At_Start );
		AddBoolean( 'MINIMAPON' , Display_Mini_Map );
{$IFDEF PATCH_GH}
		AddBoolean( 'MINIMAP_WITH_ALLGEARS' , Display_Mini_Map_with_All_Gears );
{$ENDIF PATCH_GH}

		writeln( F , 'SCREENHEIGHT ' + BStr( ScreenRows ) );
		writeln( F , 'SCREENWIDTH ' + BStr( ScreenColumns ) );

		AddBoolean( 'FULLSCREEN' , DoFullScreen );
		AddBoolean( 'NOMOUSE' , not Mouse_Active );
		AddBoolean( 'NOPILLAGE' , not Pillage_On );
		AddBoolean( 'USETACTICSMODE' , UseTacticsMode );

		AddBoolean( 'ADVANCEDCOLORS' ,  UseAdvancedColoring );
		AddBoolean( 'ACCESSIBILITY_ON' ,  Accessibility_On );

{$IFDEF PATCH_I18N}
		AddTrueFalse( 'I18N_USEORIGINALNAME' , I18N_UseOriginalName );
		AddTrueFalse( 'I18N_USENAMEORG' , I18N_UseNameORG );
		writeln( F , 'FONTFILEBIG ' + FontSearchName_Big[1].FontFile + ' ' + BStr( FontSearchName_Big[1].FontFace ) );
		writeln( F , 'FONTFILESMALL ' + FontSearchName_Small[1].FontFile + ' ' + BStr( FontSearchName_Small[1].FontFace ) );
		writeln( F , 'FONTSIZEBIG ' + BStr( FontSize_Big ) );
		writeln( F , 'FONTSIZESMALL ' + BStr( FontSize_Small ) );
  {IF DEFINED(Windows)}
		writeln( F , 'FONTNAMEOTHER ' + MSWINGUI_FontName );
		writeln( F , 'FONTWEIGHTOTHER ' + BStr( MSWINGUI_FontWeight ) );
		writeln( F , 'FONTSIZEOTHER ' + BStr( MSWINGUI_FontSize ) );
  {ENDIF}
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_JPSSDL}
		writeln( F , 'PADLEFT ' + BStr( Pad_Left ) );
		writeln( F , 'PADTOP ' + BStr( Pad_Top ) );
		AddTrueFalse( 'SKIPANIM' , SkipAnim );
		writeln( F , 'DRAWWALLMODE ' + BStr( DrawWallMode ) );
{$ENDIF PATCH_JPSSDL}
{$IFDEF PATCH_GH}
		AddTrueFalse( 'SDL_ACCELERATED' , SDL_Accelerated );
		AddTrueFalse( 'SDL_PRESENTVSYNC' , SDL_PresentVsync );
		AddTrueFalse( 'SDL_NOTIMEEVENT' , SDL_NoTimeEvent );
		AddTrueFalse( 'FRAMESKIP' , FrameSkip );
		writeln( F , 'FRAMEINTERVAL ' + BStr( FrameInterval ) );
		writeln( F , 'SLEEPGRANULARITY ' + BStr( SleepGranularity ) );
		writeln( F , 'KEYSAMPLINGINTERVAL ' + BStr( KeysamplingInterval ) );
		for ColorNum := 1 to ColorTable_Num do begin
			writeln( F , 'COLOR ' + ColorTable[ColorNum].Name + ' ' + BStr( ColorTable[ColorNum].DataPtr^.r ) + ' ' + BStr( ColorTable[ColorNum].DataPtr^.g ) + ' ' + BStr( ColorTable[ColorNum].DataPtr^.b ) );
		end;
		for ColorNum := 1 to SDLColorTable_Num do begin
			writeln( F , 'SDL_COLORS ' + SDLColorTable[ColorNum].Name + ' <' + SDLColorTable[ColorNum].DataPtr + '>' );
		end;
		AddTrueFalse( 'SDL_MINI' , SDL_Mini );
		writeln( F , 'CUI_SCREENSIZE ' + BStr( CUI_ScreenSize_Width ) + ' ' + BStr( CUI_ScreenSize_Height ) );
		writeln( F , 'SDL_SCREENPOS ' + BStr( ScreenPos_X ) + ' ' + BStr( ScreenPos_Y ) );
		writeln( F , 'SDL_SCREENSIZE ' + BStr( ScreenSize_Width ) + ' ' + BStr( ScreenSize_Height ) );
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
		writeln( F , 'SDL_QRLVIEWER_SCREENSIZE ' + BStr( QRLViewer_ScreenSize_Width ) + ' ' + BStr( QRLViewer_ScreenSize_Height ) );
		writeln( F , 'SDL_QRLVIEWER_SCREENPOS ' + BStr( QRLViewer_ScreenPos_X ) + ' ' + BStr( QRLViewer_ScreenPos_Y ) );
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_I18N}
		AddTrueFalse( 'SDL_AAFONT' , SDL_AAFont );
		AddTrueFalse( 'SDL_AAFONT_SHADED' , SDL_AAFont_Shaded );
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
		AddTrueFalse( 'ENABLE_ARENAMODE' , Enable_ArenaMode );
		AddTrueFalse( 'ENABLE_EDITMAP' , Enable_EditMap );
		AddTrueFalse( 'ENABLE_POINTANIMATION' , Enable_PointAnimation );
		AddTrueFalse( 'ENABLE_MOUSECLICK_OUTSIDETHEMENUAREA' , Enable_MouseClick_OutsideTheMenuArea );
{$ENDIF PATCH_GH}
{$IFDEF PATCH_l0ugh}
		AddTrueFalse( 'KEYBIND_ROGUEMOVE' , KeyBind_RogueMove );
{$ENDIF PATCH_l0ugh}
{$IFDEF PATCH_GH}
		AddTrueFalse( 'SELECTMENU_SCROLL_BY_EDGE' , SelectMenu_Scroll_by_Edge );
		AddTrueFalse( 'SHOW_MENUSCROLLBAR' , Show_MenuScrollbar );
		AddTrueFalse( 'SDL_SHOW_MENUSCROLLBAR' , SDL_Show_MenuScrollbar );
		writeln( F , 'SDL_SCROLLBAR_SIZE ' + BStr( SDL_Scrollbar_Size ) );
		writeln( F , 'SDL_CHANGE_DIALOGHEIGHT ' + BStr( SDL_Change_DialogHeight ) );
		AddTrueFalse( 'SHOW_MENUPAGE' , Show_MenuPage );
		AddTrueFalse( 'CHEAT_DISPLAYGEARINFO' , Cheat_DisplayGearInfo );
		AddTrueFalse( 'CHEAT_DISPLAY_MEMONUMBER' , Cheat_Display_MemoNumber );
		AddTrueFalse( 'CHEAT_ASCII_DISPLAY_CHARACTERDISPLAY' , Cheat_ASCII_Display_CharacterDisplay );
{$ENDIF PATCH_GH}
{$IFDEF PATCH_CHEAT}
		AddTrueFalse( 'CHEAT_DISPLAY' , Cheat_Display );
		AddTrueFalse( 'CHEAT_DISPLAY_DESIG' , Cheat_Display_DESIG );
		AddTrueFalse( 'CHEAT_DISPLAY_OVERLOAD' , Cheat_Display_OverLoad );
		AddTrueFalse( 'CHEAT_DISPLAY_DAMAGEPERCENT' , Cheat_Display_DamagePercent );
		AddTrueFalse( 'CHEAT_DISPLAY_SPEEDOMETER' , Cheat_Display_SpeedoMeter );
		AddTrueFalse( 'CHEAT_DISPLAY_PV' , Cheat_Display_PV );
		AddTrueFalse( 'CHEAT_SHOW_ALWAYS_EXTENDEDDESCRIPTION' , Cheat_Show_Always_ExtendedDescription );
		AddTrueFalse( 'CHEAT_SHOW_SF' , Cheat_Show_SF );
		AddTrueFalse( 'CHEAT_SHOW_SIZE' , Cheat_Show_Size );
		AddTrueFalse( 'CHEAT_SHOW_PV' , Cheat_Show_PV );
		AddTrueFalse( 'CHEAT_PRINT_TIMESTRING' , Cheat_Print_TimeString );
		AddTrueFalse( 'CHEAT_PRINT_ATTEMPTDEFENSES' , Cheat_Print_AttemptDefenses );
		AddTrueFalse( 'CHEAT_PRINT_AMMOEXPLOSION' , Cheat_Print_AmmoExplosion );
		AddTrueFalse( 'CHEAT_PRINT_DOPILLAGE' , Cheat_Print_DoPillage );
		AddTrueFalse( 'CHEAT_PRINT_DRAIN_MAXHP' , Cheat_Print_Drain_MaxHP );
		AddTrueFalse( 'CHEAT_AUTOSAVE_TRACE' , Cheat_Autosave_Trace );
		AddTrueFalse( 'CHEAT_AUTOSAVE_WITH_TIMESTAMP' , Cheat_Autosave_with_Timestamp );
		AddTrueFalse( 'CHEAT_MAINMENU_ADDMENUKEY' , Cheat_MainMenu_AddMenuKey );
		AddTrueFalse( 'CHEAT_RESTORE_ADDMENUKEY' , Cheat_Restore_AddMenuKey );
		AddTrueFalse( 'CHEAT_CHAT' , Cheat_Chat );
		AddTrueFalse( 'CHEAT_CHAT_REVERSESORT' , Cheat_Chat_ReverseSort );
		AddTrueFalse( 'CHEAT_CALLSHOT' , Cheat_CallShot );
		AddTrueFalse( 'CHEAT_CALLSHOT_CANCEL' , Cheat_CallShot_Cancel );
		AddTrueFalse( 'CHEAT_CALLSHOT_OMITLOOKINFO' , Cheat_CallShot_OmitLookInfo );
		AddTrueFalse( 'CHEAT_RANGE_COLORED' , Cheat_Range_Colored );
		AddTrueFalse( 'CHEAT_RANGE_WITH_ALTITUDE' , Cheat_Range_with_Altitude );
		AddTrueFalse( 'CHEAT_MENUORDER_EDIT' , Cheat_MenuOrder_Edit );
		AddTrueFalse( 'CHEAT_MECHAPARTBROWSER_DELETE' , Cheat_MechaPartBrowser_Delete );
		AddTrueFalse( 'CHEAT_NPC_EDIT' , Cheat_NPC_Edit );
		AddTrueFalse( 'CHEAT_UNLIMITED_SPRITE' , Cheat_Unlimited_Sprite );
		AddTrueFalse( 'CHEAT_UNLIMITED_PORTRAIT' , Cheat_Unlimited_Portrait );
		AddTrueFalse( 'CHEAT_LOOKINFO' , Cheat_LookInfo );
		AddTrueFalse( 'CHEAT_ENABLE_LIMIT_SELLINGPRICE' , Cheat_Enable_Limit_SellingPrice );
		AddTrueFalse( 'CHEAT_BUYSTUFF_SHOWSUBITEM' , Cheat_BuyStuff_ShowSubItem );
		AddTrueFalse( 'CHEAT_BUYSTUFF_MECHA_SHOWSUBITEM' , Cheat_BuyStuff_Mecha_ShowSubItem );
		AddTrueFalse( 'CHEAT_BUYSTUFF_SORT' , Cheat_BuyStuff_Sort );
		AddTrueFalse( 'CHEAT_SELLSTUFF_SHOWSUBITEM' , Cheat_SellStuff_ShowSubItem );
		AddTrueFalse( 'CHEAT_SELLSTUFF_SORT' , Cheat_SellStuff_Sort );
		AddTrueFalse( 'CHEAT_SELLSTUFF_KEEPPOSITION' , Cheat_SellStuff_KeepPosition );
		AddTrueFalse( 'CHEAT_EQPMENU_ADDMENUKEY' , Cheat_EqpMenu_AddMenuKey );
		AddTrueFalse( 'CHEAT_EQPMENU_KEEPPOSITION' , Cheat_EqpMenu_KeepPosition );
		AddTrueFalse( 'CHEAT_EQPMENU_SHOWSUBITEM' , Cheat_EqpMenu_ShowSubItem );
		AddTrueFalse( 'CHEAT_EQPMENU_SHOWMASSMETER' , Cheat_EqpMenu_ShowMassMeter );
		AddTrueFalse( 'CHEAT_EQPMENU_SHOWFULLGEARNAME' , Cheat_EqpMenu_ShowFullGearName );
		AddTrueFalse( 'CHEAT_INVMENU_KEEPPOSITION' , Cheat_InvMenu_KeepPosition );
		AddTrueFalse( 'CHEAT_INVMENU_SHOWSUBITEM' , Cheat_InvMenu_ShowSubItem );
		AddTrueFalse( 'CHEAT_INVMENU_NOSORT' , Cheat_InvMenu_NoSort );
		AddTrueFalse( 'CHEAT_SHOW_COMPONENTMASS' , Cheat_Show_ComponentMass );
		AddTrueFalse( 'CHEAT_MECHADESCRIPTION_SHOWMASSMETER' , Cheat_MechaDescription_ShowMassMeter );
		AddTrueFalse( 'CHEAT_MECHAPARTEDITOR_ADDMENUKEY' , Cheat_MechaPartEditor_AddMenuKey );
		AddTrueFalse( 'CHEAT_MECHAPARTEDITOR_KEEPPOSITION' , Cheat_MechaPartEditor_KeepPosition );
		AddTrueFalse( 'CHEAT_PCVIEW_TRAINING_ADDMENUKEY' , Cheat_PCVIEW_Training_AddMenuKey );
		AddTrueFalse( 'CHEAT_PCVIEW_TRAINING_KEEPPOSITION' , Cheat_PCVIEW_Training_KeepPosition );
		AddTrueFalse( 'CHEAT_FIELDHQ_MECHA_NOSORT' , Cheat_FieldHQ_Mecha_NoSort );
		AddTrueFalse( 'CHEAT_FIELDHQ_MECHA_KEEPPOSITION' , Cheat_FieldHQ_Mecha_KeepPosition );
		AddTrueFalse( 'CHEAT_FIELDHQ_ADDMENUKEY' , Cheat_FieldHQ_AddMenuKey );
		AddTrueFalse( 'CHEAT_INSTALLMISC_SHOWPARENTITEM' , Cheat_InstallMisc_ShowParentItem );
		AddTrueFalse( 'CHEAT_EQUIPITEM_SHOWPARENTITEM' , Cheat_EquipItem_ShowParentItem );
		AddTrueFalse( 'CHEAT_INSTALLMISC_SHOWINVSTR' , Cheat_InstallMisc_ShowInvStr );
		AddTrueFalse( 'CHEAT_EQUIPITEM_SHOWINVSTR' , Cheat_EquipItem_ShowInvStr );
		AddTrueFalse( 'CHEAT_INSTALLAMMO_SHOWSUBITEM' , Cheat_InstallAmmo_ShowSubItem );
		AddTrueFalse( 'CHEAT_EQUIPITEM_SHOWSUBITEM' , Cheat_EquipItem_ShowSubItem );
		AddTrueFalse( 'CHEAT_INSTALL_SHOWSUBITEM' , Cheat_Install_ShowSubItem );
		AddTrueFalse( 'CHEAT_INSTALLCYBERWARE_SHOWSUBITEM' , Cheat_InstallCyberware_ShowSubItem );
		AddTrueFalse( 'CHEAT_EXTENDEDDESCRIPTION_SHOWHIGHOUTPUT' , Cheat_ExtendedDescription_ShowHighOutput );
		AddTrueFalse( 'CHEAT_GEARNAME_ADDSCALENUMBER' , Cheat_GearName_AddScaleNumber );
		AddTrueFalse( 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGMODULE' , Cheat_GearName_AddClassNumber_GGModule );
		AddTrueFalse( 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGMECHA' , Cheat_GearName_AddClassNumber_GGMecha );
		AddTrueFalse( 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGHOLDER' , Cheat_GearName_AddClassNumber_GGHolder );
		AddTrueFalse( 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGSUPPORT' , Cheat_GearName_AddClassNumber_GGSupport );
		AddTrueFalse( 'CHEAT_GEARNAME_ADDCLASSNUMBER_GGCONSUMABLE' , Cheat_GearName_AddClassNumber_GGConsumable );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_LIMITLESS' , Cheat_MechaCustomize_Limitless );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREESUPPORT' , Cheat_MechaCustomize_FreeSupport );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREECOCKPIT' , Cheat_MechaCustomize_FreeCockpit );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREEMASTERGEAR' , Cheat_MechaCustomize_FreeMasterGear );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREEPARENT' , Cheat_MechaCustomize_FreeParent );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREESCALE' , Cheat_MechaCustomize_FreeScale );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREEMODIFIER' , Cheat_MechaCustomize_FreeModifier );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREEBODYMODULE' , Cheat_MechaCustomize_FreeBodyModule );
		AddTrueFalse( 'CHEAT_MECHACUSTOMIZE_FREEINTEGRAL' , Cheat_MechaCustomize_FreeIntegral );
		AddTrueFalse( 'CHEAT_TRADE_NOTSAFEAREA' , Cheat_Trade_NotSafeArea );
		AddTrueFalse( 'CHEAT_TRADE_LANCEMATEMENUNAME' , Cheat_Trade_LanceMateMenuName );
		AddTrueFalse( 'CHEAT_ROGUELIKE_DEATH' , Cheat_Roguelike_Death );
		AddTrueFalse( 'CHEAT_ARENAMODE_MAINMENU_ADDMENUKEY' , Cheat_ArenaMode_MainMenu_AddMenuKey );
		AddTrueFalse( 'CHEAT_ARENAMODE_PILOTSMENU_ADDMENUKEY' , Cheat_ArenaMode_PilotsMenu_AddMenuKey );
		AddTrueFalse( 'CHEAT_ARENAMODE_MECHAMENU_ADDMENUKEY' , Cheat_ArenaMode_MechaMenu_AddMenuKey );
		AddTrueFalse( 'CHEAT_ARENAMODE_PILOTSHQ_ADDMENUKEY' , Cheat_ArenaMode_PilotsHQ_AddMenuKey );
		AddTrueFalse( 'CHEAT_ARENAMODE_MECHAHQ_ADDMENUKEY' , Cheat_ArenaMode_MechaHQ_AddMenuKey );
		AddTrueFalse( 'CHEAT_ARENAMODE_ALLRECOVERYINHQ' , Cheat_ArenaMode_AllRecoveryInHQ );
		AddTrueFalse( 'CHEAT_ARENAMODE_INVENTORYINHQ' , Cheat_ArenaMode_InventoryInHQ );
		AddTrueFalse( 'CHEAT_ARENAMODE_FIELDHQINHQ' , Cheat_ArenaMode_FieldHQInHQ );
		AddTrueFalse( 'CHEAT_ARENAMODE_MAPSELECT' , Cheat_ArenaMode_MapSelect );
		AddTrueFalse( 'CHEAT_THISITEMWASSELECTED_ADDMENUKEY' , Cheat_ThisItemWasSelected_AddMenuKey );
		AddTrueFalse( 'CHEAT_ENABLECOCKPITBARRIER' , Cheat_EnableCockpitBarrier );
		AddTrueFalse( 'CHEAT_ENABLECOCKPITBARRIER_HAND' , Cheat_EnableCockpitBarrier_Hand );
		AddTrueFalse( 'CHEAT_DONOTRUNWHENMOUSECLICKED' , Cheat_DoNotRunWhenMouseClicked );
		AddTrueFalse( 'CHEAT_DONOTTARGETMATERIAL' , Cheat_DoNotTargetMaterial );
		AddTrueFalse( 'CHEAT_ENABLE_SUBINVMENU' , Cheat_Enable_SubInvMenu );
		AddTrueFalse( 'CHEAT_NPCONMECHAWILLREPAIR' , Cheat_NPConMechaWillRepair );
		AddTrueFalse( 'CHEAT_AVOID_ZOMBIE' , Cheat_Avoid_Zombie );
		AddTrueFalse( 'CHEAT_NPC_AVOIDATTACKTONEUTRALITY' , Cheat_NPC_AvoidAttackToNeutrality );
		AddTrueFalse( 'CHEAT_NPC_USEGRENADE' , Cheat_NPC_UseGrenade );
		AddTrueFalse( 'CHEAT_DONOTROUNDUP_ARP' , Cheat_DoNotRoundUp_ARP );
		AddTrueFalse( 'CHEAT_RELOADALLMECHA' , Cheat_ReloadAllMecha );
		AddTrueFalse( 'CHEAT_SHOW_WEAPONRECHARGE' , Cheat_Show_WeaponRecharge );
		AddTrueFalse( 'CHEAT_FIX_SOLVELINE' , Cheat_Fix_SolveLine );
		AddTrueFalse( 'CHEAT_SHOW_RANGECOVER' , Cheat_Show_RangeCover );
		AddTrueFalse( 'CHEAT_SELECTSPRITE' , Cheat_SelectSprite );
		AddTrueFalse( 'CHEAT_SHOW_NEEDHAND' , Cheat_Show_NeedHand );
{$ENDIF PATCH_CHEAT}
{$IFDEF PATCH_HEART}
		AddTrueFalse( 'CHEAT_ALWAYS_GETPLAYERINPUT' , Cheat_Always_GetPlayerInput );
		AddTrueFalse( 'DEBUG_ENABLELUADEBUGGER' , DEBUG_EnableLuaDebugger );
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_BACKPORT}
		AddTrueFalse( 'BACKPORT_CALIBER' , Backport_Caliber );
		AddTrueFalse( 'BACKPORT_CALIBER_GH1COMPATIBLE' , Backport_Caliber_GH1Compatible );
{$ENDIF PATCH_BACKPORT}
{$IFDEF PATCH_GH}
		AddTrueFalse( 'DEBUG_MEMORYLEAK' , DEBUG_MemoryLeak );
		AddTrueFalse( 'DEBUG_TRACEMACRO' , DEBUG_TraceMacro );
		AddTrueFalse( 'DEBUG_GRABBED_GEAR' , DEBUG_Grabbed_Gear );
		AddTrueFalse( 'DEBUG_SCRIPT_DYNAMICENCOUNTER' , DEBUG_SCRIPT_DynamicEncounter );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_NEWGEAR' , DEBUG_DONOT_NIL_Grabbed_Gear_when_NewGear );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_DISPOSEGEAR' , DEBUG_DONOT_NIL_Grabbed_Gear_when_DisposeGear );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_DELEGEGG' , DEBUG_DONOT_NIL_Grabbed_Gear_when_DelegeGG );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_ENDSTORY' , DEBUG_DONOT_NIL_Grabbed_Gear_when_EndStory );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_CLEANUPSTORYPLOTS' , DEBUG_DONOT_NIL_Grabbed_Gear_when_CleanupStoryPlots );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_PURGE_GG_ABSOLUTELYNOTHING' , DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_AbsolutelyNothing );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_MARK_GG_DISPOSEGEAR' , DEBUG_DONOT_NIL_Grabbed_Gear_when_Mark_GG_DisposeGear );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_PURGE_GG_DISPOSEGEAR' , DEBUG_DONOT_NIL_Grabbed_Gear_when_Purge_GG_DisposeGear );
		AddTrueFalse( 'DEBUG_DONOT_NIL_GRABBED_GEAR_WHEN_CHANGE_SCENE' , DEBUG_DONOT_NIL_Grabbed_Gear_when_Change_Scene );
		AddTrueFalse( 'DEBUG_DONOT_NIL_SCRIPT_DYNAMICENCOUNTER' , DEBUG_DONOT_NIL_SCRIPT_DynamicEncounter );
		AddTrueFalse( 'DEBUG_FORCE_EXEC_MACROUPDATE_WHEN_RESTORE' , DEBUG_FORCE_EXEC_MacroUPDATE_when_Restore );
		AddTrueFalse( 'DEBUG_FORCE_EXEC_MACROSTART_WHEN_RESTORE' , DEBUG_FORCE_EXEC_MacroSTART_when_Restore );
		AddTrueFalse( 'DEBUG_STOP_MACRORESTORESTART_WHEN_RESTORE' , DEBUG_STOP_MacroRESTORESTART_when_Restore );
		AddTrueFalse( 'DEBUG_FORCE_RESTOCKRANDOMMONSTERS_WHEN_RESTORE' , DEBUG_FORCE_RestockRandomMonsters_when_Restore );
		AddTrueFalse( 'DEBUG_MAXCID' , DEBUG_MaxCID );
		AddTrueFalse( 'DEBUG_MAXNID' , DEBUG_MaxNID );
		AddTrueFalse( 'DEBUG_CANSEEALL' , DEBUG_CanSeeAll );
  {$IFDEF PATCH_HEART}
		AddTrueFalse( 'DEBUG_TRACEQRL' , DEBUG_TraceQRL );
  {$ENDIF PATCH_HEART}
{$ENDIF PATCH_GH}

		Close(F);
	end;


initialization
begin
{$IFDEF DEBUG}
	ErrorMessage_fork('DEBUG: ui4gh.pp');
{$ENDIF DEBUG}
{$IFDEF PATCH_GH}
	ScreenSize_Width  := 0;
	ScreenSize_Height := 0;
	CUI_ScreenSize_Width  := 0;
	CUI_ScreenSize_Height := 0;
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
	QRLViewer_ScreenSize_Width  := 300;
	QRLViewer_ScreenSize_Height := 240;
	QRLViewer_ScreenPos_X := -1;
	QRLViewer_ScreenPos_Y := -1;
{$ENDIF PATCH_HEART}
{$IFDEF PATCH_I18N}
	I18N_Help_Keymap_Name := LoadStringList( I18N_Help_Keymap_Name_File );
	I18N_Help_Keymap_Desc := LoadStringList( I18N_Help_Keymap_Desc_File );
	Load_I18N_Default;
{$ENDIF PATCH_I18N}

	LoadConfig;
end;


finalization
begin
{$IFDEF DEBUG}
	ErrorMessage_fork('DEBUG: ui4gh.pp(finalization)');
{$ENDIF DEBUG}
	SaveConfig;
{$IFDEF PATCH_I18N}
	DisposeSAtt( I18N_Help_Keymap_Desc );
	DisposeSAtt( I18N_Help_Keymap_Name );
{$ENDIF PATCH_I18N}
end;

end.
