{$IF DEFINED(WINDOWS)}
unit w32;


interface

uses windows;

var
	MSWINGUI_FontName: String = 'Terminal';
	MSWINGUI_FontWeight: Integer = 0;
	MSWINGUI_FontSize: Integer = 15;

{$IF (DEFINED(SDLMODE) or DEFINED(ASCII_SDL))}
Function GetSDLHWND: Windows.HWND;
{$ENDIF}

implementation

{$IFDEF DEBUG}
	{ Don't include errmsg. It cause a infinite depending loop. }
	{errmsg,}
{$ENDIF DEBUG}
{$IF DEFINED(SDLMODE) or DEFINED(ASCII_SDL)}
  {$IFDEF SDL2}
uses SDL2;
  {$ELSE SDL2}
uses SDL;
  {$ENDIF SDL2}
{$ENDIF}

{$IF (DEFINED(SDLMODE) or DEFINED(ASCII_SDL))}
Function GetSDLHWND: Windows.HWND;
var
  {$IFDEF SDL2}
	win: TSDL_Window;
	wmi: TSDL_SysWMinfo;
  {$ELSE SDL2}
	wmi: TSDL_SysWMinfo;
  {$ENDIF SDL2}
begin
  {$IFDEF SDL2}
	wmi.win.window := 0;		{ Fallback data. Don't forget it! }
	SDL_GetVersion( @wmi.version );
	SDL_GetWindowWMInfo( @win , @wmi );
	GetSDLHWND := wmi.win.window;
  {$ELSE SDL2}
	wmi.window := 0;		{ Fallback data. Don't forget it! }
	SDL_VERSION( wmi.version );
	SDL_GetWMInfo( @wmi );
	GetSDLHWND := wmi.window;
  {$ENDIF SDL2}
end;
{$ENDIF}



initialization
begin
{$IFDEF DEBUG}
	{ErrorMessage_fork('DEBUG: w32.pp');}
{$ENDIF DEBUG}
end;

finalization
begin
{$IFDEF DEBUG}
	{ErrorMessage_fork('DEBUG: w32.pp(finalization)');}
{$ENDIF DEBUG}
end;

end.
{$ENDIF}
